/*
 * This file is generated by Entity Class Compiler, (c) CroTeam 1997-98
 */

#line 20 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"

#include <Engine/StdH.h>
#include <Engine/Entities/InternalClasses.h>
#include <Engine/World/PhysicsProfile.h>
#include <Engine/Math/Geometry.inl>
#include <Engine/Math/Float.h>
#include <Engine/Base/Stream.h>
#include <Engine/World/World.h>
#include <Engine/Network/Network.h>
#include <Engine/Entities/EntityCollision.h>
#include <Engine/Templates/StaticArray.cpp>
#include <Engine/Templates/BSP.h>
#include <Engine/Base/ListIterator.inl>
#include <Engine/World/WorldSettings.h>
#include <Engine/World/WorldCollision.h>
#include <Engine/Math/Clipping.inl>
#include <Engine/Light/LightSource.h>
#include <Engine/Entities/LastPositions.h>
#include <Engine/Templates/StaticStackArray.cpp>
#include <Engine/Templates/DynamicArray.cpp>
#include <Engine/Base/Console.h>
#include <Engine/Base/CRC.h>
#include <Engine/Network/SessionState.h>
#include <Engine/Terrain/TerrainMisc.h>
#define CLEARMEM(var) memset(&var, 0, sizeof(var))


#include <Engine/Classes/MovableEntity.h>
#include <Engine/Classes/MovableEntity_tables.h>
#line 49 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"


#define ANYEXCEPTION  ...
template class CStaticStackArray<CBrushPolygon*>;

#define MAXCOLLISIONRETRIES 4*4
extern FLOAT phy_fCollisionCacheAhead;
extern FLOAT phy_fCollisionCacheAround;
extern FLOAT cli_fPredictionFilter;

// force breakpoint (debug)
extern INDEX dbg_bBreak;
// must be in separate function to disable stupid optimizer
extern void Breakpoint(void); 

CEntity *GetPredictedSafe(CEntity *pen)
{
  if ((pen->en_ulFlags&(ENF_PREDICTOR|ENF_TEMPPREDICTOR)) == ENF_PREDICTOR) {
    return pen->GetPredicted();
  } else {
    return pen;
  }
}

// add acceleration to velocity
static inline void AddAcceleration(
  FLOAT3D &vCurrentVelocity, const FLOAT3D &vDesiredVelocity, 
  FLOAT fAcceleration, FLOAT fDecceleration)
{
  // if desired velocity is smaller than current velocity
  if (vDesiredVelocity.Length()<vCurrentVelocity.Length()) {
    fAcceleration=fDecceleration;
  }
  // find difference between current and desired velocities
  FLOAT3D vDelta = vDesiredVelocity-vCurrentVelocity;
  // accelerate in the direction of the difference with given maximum acceleration
  FLOAT fDelta = vDelta.Length();
  if (fDelta>fAcceleration) {
    vCurrentVelocity += vDelta*(fAcceleration/fDelta);
  } else {
    vCurrentVelocity = vDesiredVelocity;
  }
}

// add gravity acceleration to velocity along an axis
static inline void AddGAcceleration(
  FLOAT3D &vCurrentVelocity, const FLOAT3D &vGDir, 
  FLOAT fGA, FLOAT fGV)
{
  // disassemble speed
  FLOAT3D vCurrentParallel, vCurrentOrthogonal;
  GetParallelAndNormalComponents(vCurrentVelocity, vGDir, vCurrentOrthogonal, vCurrentParallel);

/* 
IMPORTANT:
This is how this piece of code should look like:

  // if not already going down at max speed
  if (! (vCurrentOrthogonal%vGDir>=fGV)) {
    // add accelleration to parallel speed
    vCurrentOrthogonal+=vGDir*fGA;

    // if going down at max speed
    if (vCurrentOrthogonal%vGDir>=fGV) {
      // clamp
      vCurrentOrthogonal = vGDir*fGV;
    }
  }

But, due to need for compatibility with older versions and bad VC code generator, we use this kludge:
  */
  
// KLUDGE_BEGIN

  if (_pNetwork->ga_ulDemoMinorVersion<=2) {
    Swap(vCurrentOrthogonal, vCurrentParallel);
  }

  FLOAT3D vCurrentOrthogonalOrg=vCurrentOrthogonal;
  // add accelleration to parallel speed
  vCurrentOrthogonal+=vGDir*fGA;

  // if going down at max speed
  if (vCurrentOrthogonal%vGDir>=fGV) {
    // clamp
    vCurrentOrthogonal = vGDir*fGV;
  } else {
    vCurrentOrthogonalOrg = vCurrentOrthogonal;
  }

  if (_pNetwork->ga_ulDemoMinorVersion>2) {
    vCurrentOrthogonal=vCurrentOrthogonalOrg;
  }
// KLUDGE_END

  // assemble speed back
  vCurrentVelocity = vCurrentParallel+vCurrentOrthogonal;
}

// NOTE:
// this is pulled out into a separate function because, otherwise, VC6 generates
// invalid code when optimizing this. no clue why is that so.

#pragma inline_depth(0)
static void CheckAndAddGAcceleration(CMovableEntity *pen, FLOAT3D &vTranslationAbsolute, FLOAT fTickQuantum)
{
  // if there is forcefield involved
  if (pen->en_fForceA>0.01f) {
    // add force acceleration
    FLOAT fGV=pen->en_fForceV*fTickQuantum;
    FLOAT fGA=pen->en_fForceA*fTickQuantum*fTickQuantum;
    AddGAcceleration(vTranslationAbsolute, pen->en_vForceDir, fGA, fGV);
  }
}
#pragma inline_depth()  // see important note above


// add acceleration to velocity, but only along a plane
static inline void AddAccelerationOnPlane(
  FLOAT3D &vCurrentVelocity, const FLOAT3D &vDesiredVelocity, 
  FLOAT fAcceleration, FLOAT fDecceleration,
  const FLOAT3D &vPlaneNormal)
{
  FLOAT3D vCurrentParallel, vCurrentOrthogonal;
  GetParallelAndNormalComponents(vCurrentVelocity, vPlaneNormal, vCurrentOrthogonal, vCurrentParallel);
  FLOAT3D vDesiredParallel;
  GetNormalComponent(vDesiredVelocity, vPlaneNormal, vDesiredParallel);
  AddAcceleration(vCurrentParallel, vDesiredParallel, fAcceleration, fDecceleration);
  vCurrentVelocity = vCurrentParallel+vCurrentOrthogonal;
}

// add acceleration to velocity, for roller-coaster slope -- slow!
static inline void AddAccelerationOnPlane2(
  FLOAT3D &vCurrentVelocity, const FLOAT3D &vDesiredVelocity, 
  FLOAT fAcceleration, FLOAT fDecceleration,
  const FLOAT3D &vPlaneNormal, const FLOAT3D &vGravity)
{
  // get down and horizontal direction
  FLOAT3D vDn;
  GetNormalComponent(vGravity, vPlaneNormal, vDn);
  vDn.Normalize();
  FLOAT3D vRt = vPlaneNormal*vDn;
  vRt.Normalize();

  // add only horizontal acceleration
  FLOAT3D vCurrentParallel, vCurrentOrthogonal;
  GetParallelAndNormalComponents(vCurrentVelocity, vRt, vCurrentParallel, vCurrentOrthogonal);
  FLOAT3D vDesiredParallel;
  GetParallelComponent(vDesiredVelocity, vRt, vDesiredParallel);
  AddAcceleration(vCurrentParallel, vDesiredParallel, fAcceleration, fDecceleration);
  vCurrentVelocity = vCurrentParallel+vCurrentOrthogonal;
}

// max number of retries during movement
static INDEX _ctTryToMoveCheckCounter;
static INDEX _ctSliding;
static FLOAT3D _vSlideOffDir;   // move away direction for sliding
static FLOAT3D _vSlideDir;
static void InitTryToMove(void)
{
  _ctTryToMoveCheckCounter = MAXCOLLISIONRETRIES;
  _ctSliding = 0;
  _vSlideOffDir = FLOAT3D(0,0,0);
  _vSlideDir = FLOAT3D(0,0,0);
}

// array of forces for current entity
class CEntityForce {
public:
  CEntityPointer ef_penEntity;
  INDEX ef_iForceType;
  FLOAT ef_fRatio;    // how much of entity this force gets [0-1]
  inline void Clear(void) {
    ef_penEntity = NULL;
  };
  ~CEntityForce(void) {
    Clear();
  };
};
static CStaticStackArray<CEntityForce> _aefForces;

void ClearMovableEntityCaches(void)
{
  _aefForces.Clear();
}


void CMovableEntity::SetDefaultProperties(void) {
  en_vDesiredTranslationRelative = FLOAT3D(0.0f , 0.0f , 0.0f);
  en_aDesiredRotationRelative = ANGLE3D(0 , 0 , 0);
  en_vCurrentTranslationAbsolute = FLOAT3D(0.0f , 0.0f , 0.0f);
  en_aCurrentRotationAbsolute = ANGLE3D(0 , 0 , 0);
  en_penReference = NULL;
  en_vReferencePlane = FLOAT3D(0.0f , 0.0f , 0.0f);
  en_iReferenceSurface = 0;
  en_penLastValidReference = NULL;
  en_tmLastSignificantVerticalMovement = 0.0f;
  en_tmLastBreathed = 0;
  en_tmMaxHoldBreath = 5.0f;
  en_fDensity = 5000.0f;
  en_tmLastSwimDamage = 0;
  en_iUpContent = 0;
  en_iDnContent = 0;
  en_fImmersionFactor = 1.0f;
  en_vGravityDir = FLOAT3D(0 , - 1 , 0);
  en_fGravityA = 0.0f;
  en_fGravityV = 0.0f;
  en_vForceDir = FLOAT3D(1 , 0 , 0);
  en_fForceA = 0.0f;
  en_fForceV = 0.0f;
  en_tmJumped = 0;
  en_tmMaxJumpControl = 0.5f;
  en_fJumpControlMultiplier = 0.5f;
  en_fAcceleration = 200.0f;
  en_fDeceleration = 40.0f;
  en_fStepUpHeight = 1.0f;
  en_fStepDnHeight = -1.0f;
  en_fBounceDampParallel = 0.5f;
  en_fBounceDampNormal = 0.5f;
  en_fCollisionSpeedLimit = 20.0f;
  en_fCollisionDamageFactor = 20.0f;
  en_boxMovingEstimate = FLOATaabbox3D(FLOAT3D (0 , 0 , 0) , 0.01f);
  en_boxNearCached = FLOATaabbox3D(FLOAT3D (0 , 0 , 0) , 0.01f);
  en_vIntendedTranslation = FLOAT3D(0 , 0 , 0);
  en_mIntendedRotation = FLOATmatrix3D(0);
  CRationalEntity::SetDefaultProperties();
}
  
#line 332 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
void CMovableEntity::ResetPredictionFilter(void) 
#line 333 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
{
#line 334 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
en_tmLastPredictionHead  = - 2;
#line 335 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
en_vLastHead  = en_plPlacement  . pl_PositionVector ;
#line 336 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
en_vPredError  = en_vPredErrorLast  = FLOAT3D (0 , 0 , 0);
#line 337 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
   CMovableEntity::CMovableEntity(void) 
#line 341 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
{
#line 342 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
en_pbpoStandOn  = NULL ;
#line 343 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
en_apbpoNearPolygons  . SetAllocationStep  (5);
#line 344 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
ResetPredictionFilter  ();
#line 345 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
   CMovableEntity:: ~ CMovableEntity(void) 
#line 347 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
{
#line 348 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
  void CMovableEntity::OnInitialize(const CEntityEvent & eeInput) 
#line 352 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
{
#line 353 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
CRationalEntity  :: OnInitialize  (eeInput );
#line 354 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
ClearTemporaryData  ();
#line 355 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
en_vIntendedTranslation  = FLOAT3D (0 , 0 , 0);
#line 356 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
en_mIntendedRotation  . Diagonal  (1.0f);
#line 357 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
en_boxNearCached  = FLOATaabbox3D ();
#line 358 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
en_boxMovingEstimate  = FLOATaabbox3D ();
#line 359 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
en_pbpoStandOn  = NULL ;
#line 360 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
  void CMovableEntity::OnEnd(void) 
#line 363 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
{
#line 365 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
if(en_lnInMovers  . IsLinked  ()){
#line 366 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
en_lnInMovers  . Remove  ();
#line 367 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
#line 368 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
ClearTemporaryData  ();
#line 369 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
en_boxNearCached  = FLOATaabbox3D ();
#line 370 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
en_boxMovingEstimate  = FLOATaabbox3D ();
#line 371 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
CRationalEntity  :: OnEnd  ();
#line 372 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
  void CMovableEntity::Copy(CEntity & enOther,ULONG ulFlags) 
#line 374 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
{
#line 375 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
CRationalEntity  :: Copy  (enOther  , ulFlags );
#line 376 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
CMovableEntity  * pmenOther  = (CMovableEntity  *) (& enOther );
#line 378 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
if(ulFlags  & COPY_PREDICTOR ){
#line 379 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
en_plLastPlacement  = pmenOther  -> en_plLastPlacement ;
#line 380 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
en_vNextPosition  = pmenOther  -> en_vNextPosition ;
#line 381 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
en_mNextRotation  = pmenOther  -> en_mNextRotation ;
#line 384 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
en_vAppliedTranslation  = pmenOther  -> en_vAppliedTranslation ;
#line 385 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
en_mAppliedRotation  = pmenOther  -> en_mAppliedRotation ;
#line 386 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
en_boxNearCached  = pmenOther  -> en_boxNearCached ;
#line 387 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
en_boxMovingEstimate  = pmenOther  -> en_boxMovingEstimate ;
#line 388 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
en_pbpoStandOn  = pmenOther  -> en_pbpoStandOn ;
#line 389 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
en_apbpoNearPolygons  = pmenOther  -> en_apbpoNearPolygons ;
#line 390 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}else {
#line 391 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
ClearTemporaryData  ();
#line 392 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
en_boxNearCached  = FLOATaabbox3D ();
#line 393 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
en_boxMovingEstimate  = FLOATaabbox3D ();
#line 394 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
en_pbpoStandOn  = NULL ;
#line 395 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
#line 397 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
ResetPredictionFilter  ();
#line 398 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
en_plLastPlacement  = pmenOther  -> en_plLastPlacement ;
#line 399 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
if(pmenOther  -> en_lnInMovers  . IsLinked  ()){
#line 400 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
AddToMovers  ();
#line 401 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
#line 402 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
  
#line 404 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
void CMovableEntity::ClearTemporaryData(void) 
#line 405 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
{
#line 406 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
en_plLastPlacement  = en_plPlacement ;
#line 408 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
en_vNextPosition  = en_plPlacement  . pl_PositionVector ;
#line 409 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
en_mNextRotation  = en_mRotation ;
#line 412 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
en_vAppliedTranslation  = FLOAT3D (0 , 0 , 0);
#line 413 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
en_mAppliedRotation  . Diagonal  (1.0f);
#line 414 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
ResetPredictionFilter  ();
#line 420 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
  void CMovableEntity::ChecksumForSync(ULONG & ulCRC,INDEX iExtensiveSyncCheck) 
#line 424 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
{
#line 425 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
CRationalEntity  :: ChecksumForSync  (ulCRC  , iExtensiveSyncCheck );
#line 426 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
if(iExtensiveSyncCheck  > 0){
#line 427 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
if(en_pbpoStandOn  != NULL ){
#line 428 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
CRC_AddLONG  (ulCRC  , en_pbpoStandOn  -> bpo_iInWorld );
#line 429 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
#line 430 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
CRC_AddFLOAT  (ulCRC  , en_apbpoNearPolygons  . Count  ());
#line 431 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
if(iExtensiveSyncCheck  > 2){
#line 432 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
for(INDEX i  = 0;i  < en_apbpoNearPolygons  . Count  ();i  ++){
#line 433 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
CRC_AddLONG  (ulCRC  , en_apbpoNearPolygons  [ i  ] -> bpo_iInWorld );
#line 434 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
#line 435 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
#line 436 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
CRC_AddBlock  (ulCRC  , (UBYTE  *) & en_vReferencePlane  , sizeof  (en_vReferencePlane ));
#line 437 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
CRC_AddBlock  (ulCRC  , (UBYTE  *) & en_vDesiredTranslationRelative  , sizeof  (en_vDesiredTranslationRelative ));
#line 438 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
CRC_AddBlock  (ulCRC  , (UBYTE  *) & en_aDesiredRotationRelative  , sizeof  (en_aDesiredRotationRelative ));
#line 439 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
CRC_AddBlock  (ulCRC  , (UBYTE  *) & en_vCurrentTranslationAbsolute  , sizeof  (en_vCurrentTranslationAbsolute ));
#line 440 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
CRC_AddBlock  (ulCRC  , (UBYTE  *) & en_aCurrentRotationAbsolute  , sizeof  (en_aCurrentRotationAbsolute ));
#line 441 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
#line 442 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
  void CMovableEntity::DumpSync_t(CTStream & strm,INDEX iExtensiveSyncCheck) 
#line 446 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
{
#line 447 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
CRationalEntity  :: DumpSync_t  (strm  , iExtensiveSyncCheck );
#line 448 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
if(iExtensiveSyncCheck  > 0){
#line 449 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
strm  . FPrintF_t  ("standon polygon: ");
#line 450 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
if(en_pbpoStandOn  != NULL ){
#line 451 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
strm  . FPrintF_t  ("%d\n" , en_pbpoStandOn  -> bpo_iInWorld );
#line 452 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}else {
#line 453 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
strm  . FPrintF_t  ("<none>\n");
#line 454 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
#line 455 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
strm  . FPrintF_t  ("near polygons: %d - " , en_apbpoNearPolygons  . Count  ());
#line 456 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
if(iExtensiveSyncCheck  > 2){
#line 457 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
for(INDEX i  = 0;i  < en_apbpoNearPolygons  . Count  ();i  ++){
#line 458 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
strm  . FPrintF_t  ("%d, " , en_apbpoNearPolygons  [ i  ] -> bpo_iInWorld );
#line 459 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
#line 460 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
#line 461 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
strm  . FPrintF_t  ("\n");
#line 462 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
strm  . FPrintF_t  ("desired translation: %g, %g, %g (%08X %08X %08X)\n" , 
#line 463 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
en_vDesiredTranslationRelative  (1) , 
#line 464 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
en_vDesiredTranslationRelative  (2) , 
#line 465 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
en_vDesiredTranslationRelative  (3) , 
#line 466 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
(ULONG  &) en_vDesiredTranslationRelative  (1) , 
#line 467 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
(ULONG  &) en_vDesiredTranslationRelative  (2) , 
#line 468 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
(ULONG  &) en_vDesiredTranslationRelative  (3));
#line 469 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
strm  . FPrintF_t  ("desired rotation: %g, %g, %g (%08X %08X %08X)\n" , 
#line 470 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
en_aDesiredRotationRelative  (1) , 
#line 471 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
en_aDesiredRotationRelative  (2) , 
#line 472 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
en_aDesiredRotationRelative  (3) , 
#line 473 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
(ULONG  &) en_aDesiredRotationRelative  (1) , 
#line 474 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
(ULONG  &) en_aDesiredRotationRelative  (2) , 
#line 475 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
(ULONG  &) en_aDesiredRotationRelative  (3));
#line 476 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
strm  . FPrintF_t  ("current translation: %g, %g, %g (%08X %08X %08X)\n" , 
#line 477 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
en_vCurrentTranslationAbsolute  (1) , 
#line 478 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
en_vCurrentTranslationAbsolute  (2) , 
#line 479 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
en_vCurrentTranslationAbsolute  (3) , 
#line 480 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
(ULONG  &) en_vCurrentTranslationAbsolute  (1) , 
#line 481 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
(ULONG  &) en_vCurrentTranslationAbsolute  (2) , 
#line 482 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
(ULONG  &) en_vCurrentTranslationAbsolute  (3));
#line 483 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
strm  . FPrintF_t  ("current rotation: %g, %g, %g (%08X %08X %08X)\n" , 
#line 484 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
en_aCurrentRotationAbsolute  (1) , 
#line 485 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
en_aCurrentRotationAbsolute  (2) , 
#line 486 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
en_aCurrentRotationAbsolute  (3) , 
#line 487 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
(ULONG  &) en_aCurrentRotationAbsolute  (1) , 
#line 488 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
(ULONG  &) en_aCurrentRotationAbsolute  (2) , 
#line 489 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
(ULONG  &) en_aCurrentRotationAbsolute  (3));
#line 490 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
strm  . FPrintF_t  ("reference plane: %g, %g, %g (%08X %08X %08X)\n" , 
#line 491 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
en_vReferencePlane  (1) , 
#line 492 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
en_vReferencePlane  (2) , 
#line 493 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
en_vReferencePlane  (3) , 
#line 494 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
(ULONG  &) en_vReferencePlane  (1) , 
#line 495 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
(ULONG  &) en_vReferencePlane  (2) , 
#line 496 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
(ULONG  &) en_vReferencePlane  (3));
#line 497 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
strm  . FPrintF_t  ("reference surface: %d\n" , en_iReferenceSurface );
#line 498 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
strm  . FPrintF_t  ("reference entity: ");
#line 499 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
if(en_penReference  != NULL ){
#line 500 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
strm  . FPrintF_t  ("id: %08X\n" , en_penReference  -> en_ulID );
#line 501 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}else {
#line 502 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
strm  . FPrintF_t  ("none\n");
#line 503 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
#line 504 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
#line 505 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
  void CMovableEntity::Read_t(CTStream * istr) 
#line 509 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
{
#line 510 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
CRationalEntity  :: Read_t  (istr );
#line 512 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
ClearTemporaryData  ();
#line 515 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
if(istr  -> PeekID_t  () == CChunkID  ("MENT")){
#line 516 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
istr  -> ExpectID_t  ("MENT");
#line 518 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
INDEX ibpo ;
#line 519 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
(* istr ) >> ibpo ;
#line 520 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
en_pbpoStandOn  = GetWorldPolygonPointer  (ibpo );
#line 522 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
BOOL bAnyNULLs  = FALSE ;
#line 523 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
INDEX ctbpoNear ;
#line 524 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
(* istr ) >> ctbpoNear ;
#line 525 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
if(ctbpoNear  > 0){
#line 526 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
en_apbpoNearPolygons  . PopAll  ();
#line 527 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
en_apbpoNearPolygons  . Push  (ctbpoNear );
#line 528 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
for(INDEX i  = 0;i  < ctbpoNear ;i  ++){
#line 529 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
INDEX ibpo ;
#line 530 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
(* istr ) >> ibpo ;
#line 531 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
en_apbpoNearPolygons  [ i  ] = GetWorldPolygonPointer  (ibpo );
#line 532 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
if(en_apbpoNearPolygons  [ i  ] == NULL ){
#line 533 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
bAnyNULLs  = TRUE ;
#line 534 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
#line 535 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
#line 536 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
if(bAnyNULLs ){
#line 537 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
CPrintF  ("NULL saved for near polygon!\n");
#line 538 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
en_apbpoNearPolygons  . PopAll  ();
#line 539 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
#line 540 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
#line 541 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
#line 544 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
BOOL bWasMoving ;
#line 545 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
(* istr ) >> bWasMoving ;
#line 546 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
if(bWasMoving ){
#line 548 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
AddToMovers  ();
#line 549 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
#line 550 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
  void CMovableEntity::Write_t(CTStream * ostr) 
#line 553 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
{
#line 554 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
CRationalEntity  :: Write_t  (ostr );
#line 556 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
ostr  -> WriteID_t  ("MENT");
#line 558 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
INDEX ibpo ;
#line 559 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
ibpo  = GetWorldPolygonIndex  (en_pbpoStandOn );
#line 560 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
(* ostr ) << ibpo ;
#line 562 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
INDEX ctbpoNear  = en_apbpoNearPolygons  . Count  ();
#line 563 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
(* ostr ) << ctbpoNear ;
#line 564 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
for(INDEX i  = 0;i  < ctbpoNear ;i  ++){
#line 565 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
INDEX ibpo ;
#line 566 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
ibpo  = GetWorldPolygonIndex  (en_apbpoNearPolygons  [ i  ]);
#line 567 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
(* ostr ) << ibpo ;
#line 568 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
#line 572 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
(* ostr ) << en_lnInMovers  . IsLinked  ();
#line 573 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
  CPlacement3D CMovableEntity::GetLerpedPlacement(void)const 
#line 577 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
{
#line 579 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
FLOAT fLerpFactor ;
#line 580 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
if(IsPredictor  ()){
#line 581 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
fLerpFactor  = _pTimer  -> GetLerpFactor  ();
#line 582 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}else {
#line 583 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
fLerpFactor  = _pTimer  -> GetLerpFactor2  ();
#line 584 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
#line 585 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
CPlacement3D plLerped ;
#line 586 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
plLerped  . Lerp  (en_plLastPlacement  , en_plPlacement  , fLerpFactor );
#line 587 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
CMovableEntity  * penTail  = (CMovableEntity  *) GetPredictedSafe  ((CEntity  *) this );
#line 589 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
extern  BOOL _bPredictionActive ;
#line 590 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
if(_bPredictionActive ){
#line 592 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
FLOAT3D vError  = penTail  -> en_vPredError ;
#line 593 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
vError  *= pow  (cli_fPredictionFilter  , fLerpFactor );
#line 598 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
plLerped  . pl_PositionVector  -= vError ;
#line 599 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
#line 600 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
return plLerped ;
#line 601 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
  void CMovableEntity::AddToMovers(void) 
#line 604 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
{
#line 605 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
if(! en_lnInMovers  . IsLinked  ()){
#line 606 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
en_pwoWorld  -> wo_lhMovers  . AddTail  (en_lnInMovers );
#line 607 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
#line 608 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
  void CMovableEntity::AddToMoversDuringMoving(void) 
#line 611 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
{
#line 613 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
if(en_lnInMovers  . IsLinked  ()){
#line 615 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
return ;
#line 616 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
#line 618 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
AddToMovers  ();
#line 620 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
en_ulPhysicsFlags  |= EPF_FORCEADDED ;
#line 621 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
  void CMovableEntity::SetDesiredRotation(const ANGLE3D & aRotation) 
#line 625 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
{
#line 626 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
en_aDesiredRotationRelative  = aRotation ;
#line 627 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
AddToMovers  ();
#line 628 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
  const ANGLE3D & CMovableEntity::GetDesiredRotation(void)const {return en_aDesiredRotationRelative ;}
  void CMovableEntity::SetDesiredTranslation(const FLOAT3D & vTranslation) 
#line 633 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
{
#line 634 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
en_vDesiredTranslationRelative  = vTranslation ;
#line 635 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
AddToMovers  ();
#line 636 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
  const FLOAT3D & CMovableEntity::GetDesiredTranslation(void)const {return en_vDesiredTranslationRelative ;}
  void CMovableEntity::GiveImpulseTranslationRelative(const FLOAT3D & vImpulseSpeedRelative) 
#line 641 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
{
#line 642 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
CPlacement3D plImpulseSpeedAbsolute  (vImpulseSpeedRelative  , ANGLE3D (0 , 0 , 0));
#line 643 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
plImpulseSpeedAbsolute  . RelativeToAbsolute  (
#line 644 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
CPlacement3D (FLOAT3D (0.0f , 0.0f , 0.0f) , en_plPlacement  . pl_OrientationAngle ));
#line 645 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
en_vCurrentTranslationAbsolute  += plImpulseSpeedAbsolute  . pl_PositionVector ;
#line 646 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
AddToMovers  ();
#line 647 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
  void CMovableEntity::GiveImpulseTranslationAbsolute(const FLOAT3D & vImpulseSpeed) 
#line 649 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
{
#line 650 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
en_vCurrentTranslationAbsolute  += vImpulseSpeed ;
#line 651 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
AddToMovers  ();
#line 652 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
  void CMovableEntity::LaunchAsPropelledProjectile(const FLOAT3D & vImpulseSpeedRelative,
#line 655 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
CMovableEntity * penLauncher) 
#line 656 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
{
#line 657 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
en_vDesiredTranslationRelative  = vImpulseSpeedRelative ;
#line 658 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
en_vCurrentTranslationAbsolute  += vImpulseSpeedRelative  * en_mRotation ;
#line 660 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
AddToMovers  ();
#line 661 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
  void CMovableEntity::LaunchAsFreeProjectile(const FLOAT3D & vImpulseSpeedRelative,
#line 663 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
CMovableEntity * penLauncher) 
#line 664 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
{
#line 665 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
en_vCurrentTranslationAbsolute  += vImpulseSpeedRelative  * en_mRotation ;
#line 668 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
AddToMovers  ();
#line 669 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
  void CMovableEntity::ForceStopTranslation(void) {
#line 673 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
en_vDesiredTranslationRelative  = FLOAT3D (0.0f , 0.0f , 0.0f);
#line 674 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
en_vCurrentTranslationAbsolute  = FLOAT3D (0.0f , 0.0f , 0.0f);
#line 675 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
en_vAppliedTranslation  = FLOAT3D (0.0f , 0.0f , 0.0f);
#line 676 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
  void CMovableEntity::ForceStopRotation(void) {
#line 680 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
en_aDesiredRotationRelative  = ANGLE3D (0 , 0 , 0);
#line 681 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
en_aCurrentRotationAbsolute  = ANGLE3D (0 , 0 , 0);
#line 682 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
en_mAppliedRotation  . Diagonal  (1.0f);
#line 683 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
  void CMovableEntity::ForceFullStop(void) {
#line 687 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
ForceStopTranslation  ();
#line 688 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
ForceStopRotation  ();
#line 689 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
  void CMovableEntity::FakeJump(const FLOAT3D & vOrgSpeed,const FLOAT3D & vDirection,FLOAT fStrength,
#line 693 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
FLOAT fParallelMultiplier,FLOAT fNormalMultiplier,FLOAT fMaxExitSpeed,TIME tmControl) 
#line 694 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
{
#line 696 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
en_tmJumped  = _pTimer  -> CurrentTick  () - en_tmMaxJumpControl  + tmControl ;
#line 699 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
FLOAT3D vCurrentNormal ;
#line 700 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
FLOAT3D vCurrentParallel ;
#line 701 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
GetParallelAndNormalComponents  (vOrgSpeed  , vDirection  , vCurrentParallel  , vCurrentNormal );
#line 710 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
en_vCurrentTranslationAbsolute  = 
#line 711 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
vCurrentParallel  * fParallelMultiplier  + 
#line 712 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
vCurrentNormal  * fNormalMultiplier  + 
#line 713 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
vDirection  * fStrength ;
#line 716 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
FLOAT fLength  = en_vCurrentTranslationAbsolute  . Length  ();
#line 717 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
if(fLength  > fMaxExitSpeed )
#line 718 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
{
#line 719 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
en_vCurrentTranslationAbsolute  = 
#line 720 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
en_vCurrentTranslationAbsolute  / fLength  * fMaxExitSpeed ;
#line 721 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
#line 729 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
en_penReference  = NULL ;
#line 730 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
en_pbpoStandOn  = NULL ;
#line 731 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
en_vReferencePlane  = FLOAT3D (0.0f , 0.0f , 0.0f);
#line 732 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
en_iReferenceSurface  = 0;
#line 735 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
AddToMovers  ();
#line 736 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
  ANGLE CMovableEntity::GetRelativeHeading(const FLOAT3D & vDirection) {
#line 740 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
ASSERT  (Abs  (vDirection  . Length  () - 1) < 0.001f);
#line 742 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
FLOAT fFront  = 
#line 743 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
- vDirection  (1) * en_mRotation  (1 , 3) 
#line 744 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
- vDirection  (2) * en_mRotation  (2 , 3) 
#line 745 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
- vDirection  (3) * en_mRotation  (3 , 3);
#line 747 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
FLOAT fLeft  = 
#line 748 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
- vDirection  (1) * en_mRotation  (1 , 1) 
#line 749 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
- vDirection  (2) * en_mRotation  (2 , 1) 
#line 750 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
- vDirection  (3) * en_mRotation  (3 , 1);
#line 752 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
return ATan2  (fLeft  , fFront );
#line 753 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
  ANGLE CMovableEntity::GetRelativePitch(const FLOAT3D & vDirection) {
#line 755 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
ASSERT  (Abs  (vDirection  . Length  () - 1) < 0.001f);
#line 757 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
FLOAT fFront  = 
#line 758 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
- vDirection  (1) * en_mRotation  (1 , 3) 
#line 759 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
- vDirection  (2) * en_mRotation  (2 , 3) 
#line 760 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
- vDirection  (3) * en_mRotation  (3 , 3);
#line 762 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
FLOAT fUp  = 
#line 763 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
+ vDirection  (1) * en_mRotation  (1 , 2) 
#line 764 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
+ vDirection  (2) * en_mRotation  (2 , 2) 
#line 765 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
+ vDirection  (3) * en_mRotation  (3 , 2);
#line 767 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
return ATan2  (fUp  , fFront );
#line 768 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
  void CMovableEntity::GetReferenceHeadingDirection(const FLOAT3D & vReference,ANGLE aH,FLOAT3D & vDirection) {
#line 772 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
ASSERT  (Abs  (vReference  . Length  () - 1) < 0.001f);
#line 773 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
FLOAT3D vY  (en_mRotation  (1 , 2) , en_mRotation  (2 , 2) , en_mRotation  (3 , 2));
#line 774 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
FLOAT3D vX  = (vY  * vReference ) . Normalize  ();
#line 775 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
FLOAT3D vMZ  = vY  * vX ;
#line 776 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
vDirection  = - vX  * Sin  (aH ) + vMZ  * Cos  (aH );
#line 777 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
  void CMovableEntity::GetHeadingDirection(ANGLE aH,FLOAT3D & vDirection) {
#line 781 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
FLOAT3D vX  (en_mRotation  (1 , 1) , en_mRotation  (2 , 1) , en_mRotation  (3 , 1));
#line 782 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
FLOAT3D vZ  (en_mRotation  (1 , 3) , en_mRotation  (2 , 3) , en_mRotation  (3 , 3));
#line 783 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
vDirection  = - vX  * Sin  (aH ) - vZ  * Cos  (aH );
#line 784 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
  void CMovableEntity::GetPitchDirection(ANGLE aH,FLOAT3D & vDirection) {
#line 788 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
FLOAT3D vY  (en_mRotation  (1 , 2) , en_mRotation  (2 , 2) , en_mRotation  (3 , 2));
#line 789 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
FLOAT3D vZ  (en_mRotation  (1 , 3) , en_mRotation  (2 , 3) , en_mRotation  (3 , 3));
#line 790 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
vDirection  = - vZ  * Cos  (aH ) + vY  * Sin  (aH );
#line 791 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
  
#line 794 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
CEntity * CMovableEntity::MiscDamageInflictor(void) 
#line 795 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
{
#line 798 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
if(en_penLastValidReference  != NULL ){
#line 799 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
return en_penLastValidReference ;
#line 800 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}else {
#line 801 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
CBrushSector  * pbsc  = GetFirstSector  ();
#line 802 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
if(pbsc  == NULL ){
#line 803 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
return this ;
#line 804 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}else {
#line 805 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
return pbsc  -> bsc_pbmBrushMip  -> bm_pbrBrush  -> br_penEntity ;
#line 806 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
#line 807 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
#line 808 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
  
#line 811 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
void CMovableEntity::UpdateOneSectorForce(CBrushSector & bsc,FLOAT fRatio) 
#line 812 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
{
#line 814 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
if(fRatio  < 0.01f){
#line 816 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
return ;
#line 817 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
#line 818 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
INDEX iForceType  = bsc  . GetForceType  ();
#line 819 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
CEntity  * penEntity  = bsc  . bsc_pbmBrushMip  -> bm_pbrBrush  -> br_penEntity ;
#line 839 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
CEntityForce  * pef  = NULL ;
#line 840 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
for(INDEX iForce  = 0;iForce  < _aefForces  . Count  ();iForce  ++){
#line 841 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
if(penEntity  == _aefForces  [ iForce  ] . ef_penEntity  
#line 842 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
&& iForceType  == _aefForces  [ iForce  ] . ef_iForceType ){
#line 843 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
pef  = & _aefForces  [ iForce  ];
#line 844 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
break ;
#line 845 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
#line 846 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
#line 849 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
if(pef  == NULL ){
#line 851 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
pef  = _aefForces  . Push  (1);
#line 852 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
pef  -> ef_penEntity  = penEntity ;
#line 853 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
pef  -> ef_iForceType  = iForceType ;
#line 854 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
pef  -> ef_fRatio  = 0.0f;
#line 855 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
#line 856 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
pef  -> ef_fRatio  += fRatio ;
#line 857 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
  
#line 860 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
void CMovableEntity::TestFields(INDEX & iUpContent,INDEX & iDnContent,FLOAT & fImmersionFactor) 
#line 861 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
{
#line 863 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
ASSERT  (en_RenderType  == RT_MODEL  || en_RenderType  == RT_EDITORMODEL  || en_RenderType  == RT_SKAMODEL  || en_RenderType  == RT_SKAEDITORMODEL );
#line 864 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
iUpContent  = 0;
#line 865 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
iDnContent  = 0;
#line 866 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
FLOAT fUp  = 0.0f;
#line 867 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
FLOAT fDn  = 0.0f;
#line 869 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
FLOAT3D & vOffset  = en_plPlacement  . pl_PositionVector ;
#line 870 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
FLOATmatrix3D & mRotation  = en_mRotation ;
#line 872 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
FLOAT3D vMin  = FLOAT3D (0 , en_pciCollisionInfo  -> ci_fMinHeight  , 0);
#line 873 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
FLOAT3D vMax  = FLOAT3D (0 , en_pciCollisionInfo  -> ci_fMaxHeight  , 0);
#line 874 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
vMin  = vMin  * mRotation  + vOffset ;
#line 875 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
vMax  = vMax  * mRotation  + vOffset ;
#line 877 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
CStaticArray  < CMovingSphere  > & absSpheres  = en_pciCollisionInfo  -> ci_absSpheres ;
#line 878 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
FOREACHINSTATICARRAY  (absSpheres  , CMovingSphere  , itms ){
#line 879 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
itms  -> ms_vRelativeCenter0  = itms  -> ms_vCenter  * mRotation  + vOffset ;
#line 880 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
#line 883 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
_aefForces  . PopAll  ();
#line 885 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
{FOREACHSRCOFDST  (en_rdSectors  , CBrushSector  , bsc_rsEntities  , pbsc ) 
#line 886 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
CBrushSector  & bsc  = * pbsc ;
#line 888 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
if(! bsc  . bsc_pbmBrushMip  -> IsFirstMip  ()){
#line 890 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
continue ;
#line 891 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
#line 893 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
CEntity  * penSector  = bsc  . bsc_pbmBrushMip  -> bm_pbrBrush  -> br_penEntity ;
#line 896 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
if(penSector  -> en_RenderType  != RT_BRUSH ){
#line 898 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
continue ;
#line 899 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
#line 902 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
double  dMin  , dMax ;
#line 903 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
bsc  . bsc_bspBSPTree  . FindLineMinMax  (FLOATtoDOUBLE  (vMin ) , FLOATtoDOUBLE  (vMax ) , dMin  , dMax );
#line 906 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
INDEX iContent  = bsc  . GetContentType  ();
#line 907 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
if(iContent  != 0){
#line 909 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
if(dMax  > 0.0f && dMin  < 1.0f){
#line 912 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
if(dMin  < 0.01f){
#line 914 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
iDnContent  = iContent ;
#line 915 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
fDn  = Max  (fDn  , FLOAT (dMax ));
#line 916 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
#line 918 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
if(dMax  > 0.99f){
#line 920 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
iUpContent  = iContent ;
#line 921 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
fUp  = Max  (fUp  , 1 - FLOAT (dMin ));
#line 922 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
#line 923 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
#line 924 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
#line 927 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
UpdateOneSectorForce  (bsc  , dMax  - dMin );
#line 929 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
ENDFOR ;}
#line 933 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
if(iUpContent  == iDnContent ){
#line 935 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
fImmersionFactor  = 1.0f;
#line 937 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}else {
#line 939 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
if(iUpContent  == 0){
#line 940 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
fImmersionFactor  = fDn ;
#line 941 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}else if(iDnContent  == 0){
#line 942 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
fImmersionFactor  = 1 - fUp ;
#line 943 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}else {
#line 944 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
fImmersionFactor  = Max  (fDn  , 1 - fUp );
#line 945 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
#line 947 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
if(fImmersionFactor  < 0.01f){
#line 948 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
fImmersionFactor  = 1.0f;
#line 949 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
iDnContent  = iUpContent ;
#line 950 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}else if(fImmersionFactor  > 0.99f){
#line 951 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
fImmersionFactor  = 1.0f;
#line 952 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
iUpContent  = iDnContent ;
#line 953 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
#line 954 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
#line 957 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
FLOAT3D vGravityA  (0 , 0 , 0);
#line 958 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
FLOAT3D vGravityV  (0 , 0 , 0);
#line 959 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
FLOAT3D vForceA  (0 , 0 , 0);
#line 960 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
FLOAT3D vForceV  (0 , 0 , 0);
#line 961 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
FLOAT fRatioSum  = 0.0f;
#line 963 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
{for(INDEX iForce  = 0;iForce  < _aefForces  . Count  ();iForce  ++){
#line 964 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
CForceStrength  fsGravity ;
#line 965 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
CForceStrength  fsField ;
#line 966 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
_aefForces  [ iForce  ] . ef_penEntity  -> GetForce  (
#line 967 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
_aefForces  [ iForce  ] . ef_iForceType  , en_plPlacement  . pl_PositionVector  , 
#line 968 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
fsGravity  , fsField );
#line 969 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
FLOAT fRatio  = _aefForces  [ iForce  ] . ef_fRatio ;
#line 970 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
fRatioSum  += fRatio ;
#line 971 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
vGravityA  += fsGravity  . fs_vDirection  * fsGravity  . fs_fAcceleration  * fRatio ;
#line 972 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
vGravityV  += fsGravity  . fs_vDirection  * fsGravity  . fs_fVelocity  * fRatio ;
#line 973 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
if(fsField  . fs_fAcceleration  > 0){
#line 974 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
vForceA  += fsField  . fs_vDirection  * fsField  . fs_fAcceleration  * fRatio ;
#line 975 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
vForceV  += fsField  . fs_vDirection  * fsField  . fs_fVelocity  * fRatio ;
#line 976 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
#line 977 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
_aefForces  [ iForce  ] . Clear  ();
#line 978 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}}
#line 979 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
if(fRatioSum  > 0){
#line 980 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
vGravityA  /= fRatioSum ;
#line 981 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
vGravityV  /= fRatioSum ;
#line 982 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
vForceA  /= fRatioSum ;
#line 983 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
vForceV  /= fRatioSum ;
#line 984 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
#line 985 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
en_fGravityA  = vGravityA  . Length  ();
#line 986 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
if(en_fGravityA  < 0.01f){
#line 987 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
en_fGravityA  = 0;
#line 988 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}else {
#line 989 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
en_fGravityV  = vGravityV  . Length  ();
#line 990 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
en_vGravityDir  = vGravityA  / en_fGravityA ;
#line 991 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
#line 992 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
en_fForceA  = vForceA  . Length  ();
#line 993 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
if(en_fForceA  < 0.01f){
#line 994 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
en_fForceA  = 0;
#line 995 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}else {
#line 996 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
en_fForceV  = vForceV  . Length  ();
#line 997 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
en_vForceDir  = vForceA  / en_fForceA ;
#line 998 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
#line 999 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
_aefForces  . PopAll  ();
#line 1000 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
  
#line 1003 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
void CMovableEntity::TestBreathing(CContentType & ctUp) 
#line 1004 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
{
#line 1006 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
if(! (en_ulPhysicsFlags  & (EPF_HASLUNGS  | EPF_HASGILLS ))){
#line 1008 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
return ;
#line 1009 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
#line 1011 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
BOOL bCanBreathe  = 
#line 1012 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
((ctUp  . ct_ulFlags  & CTF_BREATHABLE_LUNGS ) && (en_ulPhysicsFlags  & EPF_HASLUNGS )) || 
#line 1013 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
((ctUp  . ct_ulFlags  & CTF_BREATHABLE_GILLS ) && (en_ulPhysicsFlags  & EPF_HASGILLS ));
#line 1014 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
TIME  tmNow  = _pTimer  -> CurrentTick  ();
#line 1015 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
TIME  tmBreathDelay  = tmNow  - en_tmLastBreathed ;
#line 1017 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
if(bCanBreathe ){
#line 1019 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
en_tmLastBreathed  = tmNow ;
#line 1021 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
if(tmBreathDelay  > _pTimer  -> TickQuantum  * 2){
#line 1023 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
ETakingBreath  eTakingBreath ;
#line 1024 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
eTakingBreath  . fBreathDelay  = tmBreathDelay  / en_tmMaxHoldBreath ;
#line 1025 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
SendEvent  (eTakingBreath );
#line 1026 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
#line 1028 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}else {
#line 1030 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
if(tmBreathDelay  > en_tmMaxHoldBreath ){
#line 1032 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
InflictDirectDamage  (this  , MiscDamageInflictor  () , DMT_DROWNING  , ctUp  . ct_fDrowningDamageAmount  , 
#line 1033 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
en_plPlacement  . pl_PositionVector  , - en_vGravityDir );
#line 1035 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
en_tmLastBreathed  = tmNow  - en_tmMaxHoldBreath  + ctUp  . ct_tmDrowningDamageDelay ;
#line 1036 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
#line 1037 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
#line 1038 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
  
#line 1039 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
void CMovableEntity::TestContentDamage(CContentType & ctDn,FLOAT fImmersion) 
#line 1040 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
{
#line 1042 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
if(ctDn  . ct_fSwimDamageAmount  > 0){
#line 1043 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
TIME  tmNow  = _pTimer  -> CurrentTick  ();
#line 1045 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
if(ctDn  . ct_tmSwimDamageDelay  > 0){
#line 1047 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
if(tmNow  - en_tmLastSwimDamage  > ctDn  . ct_tmSwimDamageDelay  + _pTimer  -> TickQuantum ){
#line 1049 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
en_tmLastSwimDamage  = tmNow  + ctDn  . ct_tmSwimDamageDelay ;
#line 1050 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
return ;
#line 1051 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
#line 1052 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
#line 1054 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
if(tmNow  - en_tmLastSwimDamage  > ctDn  . ct_tmSwimDamageFrequency ){
#line 1056 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
InflictDirectDamage  (this  , MiscDamageInflictor  () , 
#line 1057 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
(DamageType ) ctDn  . ct_iSwimDamageType  , ctDn  . ct_fSwimDamageAmount  * fImmersion  , 
#line 1058 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
en_plPlacement  . pl_PositionVector  , - en_vGravityDir );
#line 1059 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
en_tmLastSwimDamage  = tmNow ;
#line 1060 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
#line 1061 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
#line 1063 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
if(ctDn  . ct_fKillImmersion  > 0 && fImmersion  >= ctDn  . ct_fKillImmersion  
#line 1064 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
&& (en_ulFlags  & ENF_ALIVE )){
#line 1066 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
InflictDirectDamage  (this  , MiscDamageInflictor  () , 
#line 1067 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
(DamageType ) ctDn  . ct_iKillDamageType  , GetHealth  () * 10.0f , 
#line 1068 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
en_plPlacement  . pl_PositionVector  , - en_vGravityDir );
#line 1069 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
#line 1070 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
  
#line 1072 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
void CMovableEntity::TestSurfaceDamage(CSurfaceType & stDn) 
#line 1073 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
{
#line 1075 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
if(stDn  . st_fWalkDamageAmount  > 0){
#line 1076 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
TIME  tmNow  = _pTimer  -> CurrentTick  ();
#line 1078 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
if(stDn  . st_tmWalkDamageDelay  > 0){
#line 1080 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
if(tmNow  - en_tmLastSwimDamage  > stDn  . st_tmWalkDamageDelay  + _pTimer  -> TickQuantum ){
#line 1082 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
en_tmLastSwimDamage  = tmNow  + stDn  . st_tmWalkDamageDelay ;
#line 1083 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
return ;
#line 1084 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
#line 1085 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
#line 1087 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
if(tmNow  - en_tmLastSwimDamage  > stDn  . st_tmWalkDamageFrequency ){
#line 1089 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
InflictDirectDamage  (this  , MiscDamageInflictor  () , 
#line 1090 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
(DamageType ) stDn  . st_iWalkDamageType  , stDn  . st_fWalkDamageAmount  , 
#line 1091 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
en_plPlacement  . pl_PositionVector  , - en_vGravityDir );
#line 1092 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
en_tmLastSwimDamage  = tmNow ;
#line 1093 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
#line 1094 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
#line 1095 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
  
#line 1098 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
void CMovableEntity::SendTouchEvent(const CClipMove & cmMove) 
#line 1099 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
{
#line 1100 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
ETouch  etouchThis ;
#line 1101 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
ETouch  etouchOther ;
#line 1102 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
etouchThis  . penOther  = cmMove  . cm_penHit ;
#line 1103 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
etouchThis  . bThisMoved  = FALSE ;
#line 1104 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
etouchThis  . plCollision  = cmMove  . cm_plClippedPlane ;
#line 1105 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
etouchOther  . penOther  = this ;
#line 1106 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
etouchOther  . bThisMoved  = TRUE ;
#line 1107 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
etouchOther  . plCollision  = cmMove  . cm_plClippedPlane ;
#line 1108 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
SendEvent  (etouchThis );
#line 1109 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
cmMove  . cm_penHit  -> SendEvent  (etouchOther );
#line 1110 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
  
#line 1113 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
void CMovableEntity::SendBlockEvent(CClipMove & cmMove) 
#line 1114 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
{
#line 1115 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
EBlock  eBlock ;
#line 1116 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
eBlock  . penOther  = cmMove  . cm_penHit ;
#line 1117 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
eBlock  . plCollision  = cmMove  . cm_plClippedPlane ;
#line 1118 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
SendEvent  (eBlock );
#line 1119 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
  
#line 1121 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
BOOL CMovableEntity::IsStandingOnPolygon(CBrushPolygon * pbpo) 
#line 1122 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
{
#line 1123 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
_pfPhysicsProfile  . StartTimer  ((INDEX) CPhysicsProfile  :: PTI_ISSTANDINGONPOLYGON );
#line 1125 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
if(en_pciCollisionInfo  == NULL  
#line 1126 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
|| ! (en_pciCollisionInfo  -> ci_ulFlags  & CIF_CANSTANDONHANDLE )){
#line 1128 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
_pfPhysicsProfile  . StopTimer  ((INDEX) CPhysicsProfile  :: PTI_ISSTANDINGONPOLYGON );
#line 1129 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
return FALSE ;
#line 1130 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
#line 1133 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
if(en_pbpoStandOn  -> bpo_pbscSector  -> bsc_pbmBrushMip  -> bm_pbrBrush  -> br_penEntity  -> en_ulCollisionFlags  == 0){
#line 1135 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
return FALSE ;
#line 1136 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
#line 1138 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
const FLOATplane3D & plPolygon  = pbpo  -> bpo_pbplPlane  -> bpl_plAbsolute ;
#line 1140 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
FLOAT3D vHandle  = en_plPlacement  . pl_PositionVector ;
#line 1141 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
vHandle  (1) += en_pciCollisionInfo  -> ci_fHandleY  * en_mRotation  (1 , 2);
#line 1142 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
vHandle  (2) += en_pciCollisionInfo  -> ci_fHandleY  * en_mRotation  (2 , 2);
#line 1143 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
vHandle  (3) += en_pciCollisionInfo  -> ci_fHandleY  * en_mRotation  (3 , 2);
#line 1144 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
vHandle  -= ((FLOAT3D &) plPolygon ) * en_pciCollisionInfo  -> ci_fHandleR ;
#line 1147 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
if(plPolygon  . PointDistance  (vHandle ) > 0.01f){
#line 1149 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
_pfPhysicsProfile  . StopTimer  ((INDEX) CPhysicsProfile  :: PTI_ISSTANDINGONPOLYGON );
#line 1150 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
return FALSE ;
#line 1151 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
#line 1154 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
INDEX iMajorAxis1  , iMajorAxis2 ;
#line 1155 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
GetMajorAxesForPlane  (plPolygon  , iMajorAxis1  , iMajorAxis2 );
#line 1158 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
CIntersector  isIntersector  (vHandle  (iMajorAxis1 ) , vHandle  (iMajorAxis2 ));
#line 1160 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
FOREACHINSTATICARRAY  (pbpo  -> bpo_abpePolygonEdges  , CBrushPolygonEdge  , itbpePolygonEdge ){
#line 1162 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
const FLOAT3D & vVertex0  = itbpePolygonEdge  -> bpe_pbedEdge  -> bed_pbvxVertex0  -> bvx_vAbsolute ;
#line 1163 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
const FLOAT3D & vVertex1  = itbpePolygonEdge  -> bpe_pbedEdge  -> bed_pbvxVertex1  -> bvx_vAbsolute ;
#line 1165 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
isIntersector  . AddEdge  (
#line 1166 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
vVertex0  (iMajorAxis1 ) , vVertex0  (iMajorAxis2 ) , 
#line 1167 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
vVertex1  (iMajorAxis1 ) , vVertex1  (iMajorAxis2 ));
#line 1168 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
#line 1171 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
if(isIntersector  . IsIntersecting  ()){
#line 1173 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
_pfPhysicsProfile  . StopTimer  ((INDEX) CPhysicsProfile  :: PTI_ISSTANDINGONPOLYGON );
#line 1174 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
return TRUE ;
#line 1176 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}else {
#line 1178 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
_pfPhysicsProfile  . StopTimer  ((INDEX) CPhysicsProfile  :: PTI_ISSTANDINGONPOLYGON );
#line 1179 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
return FALSE ;
#line 1180 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
#line 1181 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
  
#line 1184 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
BOOL CMovableEntity::IsPolygonBelowPoint(CBrushPolygon * pbpo,const FLOAT3D & vPoint,FLOAT fMaxDist) 
#line 1185 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
{
#line 1186 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
_pfPhysicsProfile  . StartTimer  ((INDEX) CPhysicsProfile  :: PTI_ISSTANDINGONPOLYGON );
#line 1189 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
if((pbpo  -> bpo_ulFlags  & BPOF_PASSABLE ) 
#line 1190 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
|| ! AllowForGroundPolygon  (pbpo )){
#line 1192 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
_pfPhysicsProfile  . StopTimer  ((INDEX) CPhysicsProfile  :: PTI_ISSTANDINGONPOLYGON );
#line 1193 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
return FALSE ;
#line 1194 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
#line 1197 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
const FLOATplane3D & plPolygon  = pbpo  -> bpo_pbplPlane  -> bpl_plAbsolute ;
#line 1200 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
FLOAT fCos  = ((const FLOAT3D &) plPolygon ) % en_vGravityDir ;
#line 1202 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
if(fCos  > - 0.01f){
#line 1204 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
_pfPhysicsProfile  . StopTimer  ((INDEX) CPhysicsProfile  :: PTI_ISSTANDINGONPOLYGON );
#line 1205 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
return FALSE ;
#line 1206 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
#line 1209 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
CSurfaceType  & stReference  = en_pwoWorld  -> wo_astSurfaceTypes  [ pbpo  -> bpo_bppProperties  . bpp_ubSurfaceType  ];
#line 1210 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
if((fCos  >= - stReference  . st_fClimbSlopeCos  && fCos  < 0) 
#line 1211 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
|| stReference  . st_ulFlags  & STF_SLIDEDOWNSLOPE ){
#line 1213 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
_pfPhysicsProfile  . StopTimer  ((INDEX) CPhysicsProfile  :: PTI_ISSTANDINGONPOLYGON );
#line 1214 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
return FALSE ;
#line 1215 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
#line 1218 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
FLOAT fD  = plPolygon  . PointDistance  (vPoint );
#line 1220 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
if(fD  < - 0.01f){
#line 1222 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
_pfPhysicsProfile  . StopTimer  ((INDEX) CPhysicsProfile  :: PTI_ISSTANDINGONPOLYGON );
#line 1223 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
return FALSE ;
#line 1224 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
#line 1227 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
FLOAT fDistance  = - fD  / fCos ;
#line 1229 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
if(fDistance  > fMaxDist ){
#line 1231 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
_pfPhysicsProfile  . StopTimer  ((INDEX) CPhysicsProfile  :: PTI_ISSTANDINGONPOLYGON );
#line 1232 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
return FALSE ;
#line 1233 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
#line 1235 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
FLOAT3D vProjected  = vPoint  + en_vGravityDir  * fDistance ;
#line 1238 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
INDEX iMajorAxis1  , iMajorAxis2 ;
#line 1239 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
GetMajorAxesForPlane  (plPolygon  , iMajorAxis1  , iMajorAxis2 );
#line 1242 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
CIntersector  isIntersector  (vProjected  (iMajorAxis1 ) , vProjected  (iMajorAxis2 ));
#line 1244 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
FOREACHINSTATICARRAY  (pbpo  -> bpo_abpePolygonEdges  , CBrushPolygonEdge  , itbpePolygonEdge ){
#line 1246 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
const FLOAT3D & vVertex0  = itbpePolygonEdge  -> bpe_pbedEdge  -> bed_pbvxVertex0  -> bvx_vAbsolute ;
#line 1247 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
const FLOAT3D & vVertex1  = itbpePolygonEdge  -> bpe_pbedEdge  -> bed_pbvxVertex1  -> bvx_vAbsolute ;
#line 1249 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
isIntersector  . AddEdge  (
#line 1250 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
vVertex0  (iMajorAxis1 ) , vVertex0  (iMajorAxis2 ) , 
#line 1251 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
vVertex1  (iMajorAxis1 ) , vVertex1  (iMajorAxis2 ));
#line 1252 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
#line 1255 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
if(isIntersector  . IsIntersecting  ()){
#line 1257 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
_pfPhysicsProfile  . StopTimer  ((INDEX) CPhysicsProfile  :: PTI_ISSTANDINGONPOLYGON );
#line 1258 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
return TRUE ;
#line 1260 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}else {
#line 1262 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
_pfPhysicsProfile  . StopTimer  ((INDEX) CPhysicsProfile  :: PTI_ISSTANDINGONPOLYGON );
#line 1263 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
return FALSE ;
#line 1264 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
#line 1265 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
  BOOL CMovableEntity::AllowForGroundPolygon(CBrushPolygon * pbpo) 
#line 1269 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
{
#line 1270 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
return TRUE ;
#line 1271 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
  
#line 1274 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
BOOL CMovableEntity::IsSomeNearPolygonBelowPoint(const FLOAT3D & vPoint,FLOAT fMaxDist) 
#line 1275 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
{
#line 1277 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
return FALSE ;
#line 1278 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
  
#line 1281 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
BOOL CMovableEntity::IsSomeSectorPolygonBelowPoint(CBrushSector * pbsc,const FLOAT3D & vPoint,FLOAT fMaxDist) 
#line 1282 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
{
#line 1284 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
FOREACHINSTATICARRAY  (pbsc  -> bsc_abpoPolygons  , CBrushPolygon  , itbpo ){
#line 1285 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
CBrushPolygon  * pbpo  = itbpo ;
#line 1287 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
if(IsPolygonBelowPoint  (pbpo  , vPoint  , fMaxDist )){
#line 1289 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
return TRUE ;
#line 1290 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
#line 1291 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
#line 1293 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
return FALSE ;
#line 1294 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
  
#line 1297 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
BOOL CMovableEntity::WouldFallInNextPosition(void) 
#line 1298 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
{
#line 1300 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
if(en_fStepDnHeight  < 0){
#line 1302 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
return FALSE ;
#line 1303 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
#line 1306 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
if(en_pbpoStandOn  != NULL  && 
#line 1307 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
IsPolygonBelowPoint  (en_pbpoStandOn  , en_vNextPosition  , en_fStepDnHeight )){
#line 1309 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
return FALSE ;
#line 1310 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
#line 1313 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
CListHead  lhActiveSectors ;
#line 1315 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
CStaticStackArray  < CBrushPolygon  * > & apbpo  = en_apbpoNearPolygons ;
#line 1317 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
for(INDEX iPolygon  = 0;iPolygon  < apbpo  . Count  ();iPolygon  ++){
#line 1318 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
CBrushPolygon  * pbpo  = apbpo  [ iPolygon  ];
#line 1320 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
if(IsPolygonBelowPoint  (pbpo  , en_vNextPosition  , en_fStepDnHeight )){
#line 1322 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
lhActiveSectors  . RemAll  ();
#line 1323 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
return FALSE ;
#line 1324 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
#line 1326 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
if(! pbpo  -> bpo_pbscSector  -> bsc_lnInActiveSectors  . IsLinked  ()){
#line 1328 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
lhActiveSectors  . AddTail  (pbpo  -> bpo_pbscSector  -> bsc_lnInActiveSectors );
#line 1329 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
#line 1330 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
#line 1335 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
if(en_penReference  != NULL  && en_penReference  -> en_RenderType  == RT_BRUSH  
#line 1336 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
&& ! (en_penReference  -> en_ulFlags  & ENF_ZONING ) 
#line 1337 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
&& en_penReference  -> en_pbrBrush  != NULL ){
#line 1339 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
CBrushMip  * pbmMip  = en_penReference  -> en_pbrBrush  -> GetFirstMip  ();
#line 1341 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
FOREACHINDYNAMICARRAY  (pbmMip  -> bm_abscSectors  , CBrushSector  , itbsc ){
#line 1343 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
if(! itbsc  -> bsc_lnInActiveSectors  . IsLinked  ()){
#line 1345 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
lhActiveSectors  . AddTail  (itbsc  -> bsc_lnInActiveSectors );
#line 1346 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
#line 1347 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
#line 1348 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
#line 1351 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
{FOREACHSRCOFDST  (en_rdSectors  , CBrushSector  , bsc_rsEntities  , pbsc );
#line 1353 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
if(! pbsc  -> bsc_lnInActiveSectors  . IsLinked  ()){
#line 1355 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
lhActiveSectors  . AddTail  (pbsc  -> bsc_lnInActiveSectors );
#line 1356 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
#line 1357 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
ENDFOR ;}
#line 1360 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
BOOL bSupportFound  = FALSE ;
#line 1361 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
FOREACHINLIST  (CBrushSector  , bsc_lnInActiveSectors  , lhActiveSectors  , itbsc ){
#line 1362 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
CBrushSector  * pbsc  = itbsc ;
#line 1364 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
if(pbsc  -> bsc_pbmBrushMip  -> bm_pbrBrush  -> br_penEntity  -> en_ulFlags  & ENF_ZONING ){
#line 1366 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
{FOREACHDSTOFSRC  (pbsc  -> bsc_rsEntities  , CEntity  , en_rdSectors  , pen );
#line 1367 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
if(pen  -> en_RenderType  == CEntity  :: RT_TERRAIN ){
#line 1368 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
if(IsTerrainBelowPoint  (pen  -> en_ptrTerrain  , en_vNextPosition  , en_fStepDnHeight  , en_vGravityDir )){
#line 1369 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
bSupportFound  = TRUE ;
#line 1370 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
goto  out ;
#line 1371 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
#line 1372 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
continue ;
#line 1373 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
#line 1374 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
if(pen  -> en_RenderType  != CEntity  :: RT_BRUSH  && 
#line 1375 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
pen  -> en_RenderType  != CEntity  :: RT_FIELDBRUSH ){
#line 1376 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
break ;
#line 1377 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
#line 1379 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
CBrushMip  * pbmMip  = pen  -> en_pbrBrush  -> GetFirstMip  ();
#line 1381 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
FOREACHINDYNAMICARRAY  (pbmMip  -> bm_abscSectors  , CBrushSector  , itbscInMip ){
#line 1383 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
if(! itbscInMip  -> bsc_lnInActiveSectors  . IsLinked  ()){
#line 1385 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
lhActiveSectors  . AddTail  (itbscInMip  -> bsc_lnInActiveSectors );
#line 1386 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
#line 1387 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
#line 1388 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
ENDFOR ;}
#line 1389 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
#line 1391 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
if(IsSomeSectorPolygonBelowPoint  (itbsc  , en_vNextPosition  , en_fStepDnHeight )){
#line 1393 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
bSupportFound  = TRUE ;
#line 1394 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
break ;
#line 1395 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
#line 1396 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
#line 1397 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
out  :;
#line 1400 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
lhActiveSectors  . RemAll  ();
#line 1403 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
return ! bSupportFound ;
#line 1404 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
  
#line 1407 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
void CMovableEntity::ClearNextPosition(void) 
#line 1408 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
{
#line 1409 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
en_vNextPosition  = en_plPlacement  . pl_PositionVector ;
#line 1410 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
en_mNextRotation  = en_mRotation ;
#line 1411 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
  
#line 1413 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
void CMovableEntity::SetPlacementFromNextPosition(void) 
#line 1414 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
{
#line 1415 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
_pfPhysicsProfile  . StartTimer  ((INDEX) CPhysicsProfile  :: PTI_SETPLACEMENTFROMNEXTPOSITION );
#line 1417 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
_pfPhysicsProfile  . IncrementTimerAveragingCounter  ((INDEX) CPhysicsProfile  :: PTI_SETPLACEMENTFROMNEXTPOSITION );
#line 1418 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
CPlacement3D plNew ;
#line 1419 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
plNew  . pl_PositionVector  = en_vNextPosition ;
#line 1420 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
DecomposeRotationMatrixNoSnap  (plNew  . pl_OrientationAngle  , en_mNextRotation );
#line 1421 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
FLOATmatrix3D mRotation ;
#line 1422 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
MakeRotationMatrixFast  (mRotation  , plNew  . pl_OrientationAngle );
#line 1423 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
SetPlacement_internal  (plNew  , mRotation  , TRUE );
#line 1437 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
_pfPhysicsProfile  . StopTimer  ((INDEX) CPhysicsProfile  :: PTI_SETPLACEMENTFROMNEXTPOSITION );
#line 1438 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
  
#line 1440 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
BOOL CMovableEntity::TryToGoUpstairs(const FLOAT3D & vTranslationAbsolute,const CSurfaceType & stHit,
#line 1441 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
BOOL bHitStairsOrg) 
#line 1442 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
{
#line 1443 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
_pfPhysicsProfile  . StartTimer  ((INDEX) CPhysicsProfile  :: PTI_TRYTOGOUPSTAIRS );
#line 1444 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
_pfPhysicsProfile  . IncrementTimerAveragingCounter  ((INDEX) CPhysicsProfile  :: PTI_TRYTOGOUPSTAIRS );
#line 1447 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
FLOAT3D vTranslationHorizontal ;
#line 1448 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
GetNormalComponent  (vTranslationAbsolute  , en_vGravityDir  , vTranslationHorizontal );
#line 1452 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
if(vTranslationHorizontal  . Length  () < 0.001f){
#line 1455 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
_pfPhysicsProfile  . StopTimer  ((INDEX) CPhysicsProfile  :: PTI_TRYTOGOUPSTAIRS );
#line 1456 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
return FALSE ;
#line 1457 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
#line 1458 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
FLOAT3D vTranslationHorizontalOrg  = vTranslationHorizontal ;
#line 1460 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
if(! bHitStairsOrg ){
#line 1462 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
vTranslationHorizontal  . Normalize  ();
#line 1463 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
vTranslationHorizontal  *= 0.5f;
#line 1464 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
#line 1467 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
CPlacement3D plOriginal  = en_plPlacement ;
#line 1470 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
FLOAT fStairsHeight  = 0;
#line 1471 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
if(stHit  . st_fStairsHeight  > 0){
#line 1472 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
fStairsHeight  = Max  (stHit  . st_fStairsHeight  , en_fStepUpHeight );
#line 1473 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}else if(stHit  . st_fStairsHeight  < 0){
#line 1474 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
fStairsHeight  = Min  (stHit  . st_fStairsHeight  , en_fStepUpHeight );
#line 1475 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
#line 1477 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
CContentType  & ctDn  = en_pwoWorld  -> wo_actContentTypes  [ en_iDnContent  ];
#line 1478 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
CContentType  & ctUp  = en_pwoWorld  -> wo_actContentTypes  [ en_iUpContent  ];
#line 1481 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
BOOL bGettingOutOfWater  = FALSE ;
#line 1482 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
if((ctDn  . ct_ulFlags  & CTF_SWIMABLE ) && ! (ctUp  . ct_ulFlags  & CTF_SWIMABLE ) 
#line 1483 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
&& en_fImmersionFactor  > 0.3f){
#line 1485 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
if(en_pciCollisionInfo  != NULL ){
#line 1486 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
fStairsHeight  = fStairsHeight  * 2 + en_fImmersionFactor  * 
#line 1487 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
(en_pciCollisionInfo  -> ci_fMaxHeight  - en_pciCollisionInfo  -> ci_fMinHeight );
#line 1489 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
bGettingOutOfWater  = TRUE ;
#line 1490 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
#line 1491 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
#line 1494 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
FLOAT3D avTranslation  [ 3 ];
#line 1495 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
avTranslation  [ 0 ] = en_vGravityDir  * - fStairsHeight ;
#line 1496 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
avTranslation  [ 1 ] = vTranslationHorizontal ;
#line 1497 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
avTranslation  [ 2 ] = en_vGravityDir  * fStairsHeight ;
#line 1500 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
for(INDEX iStep  = 0;iStep  < 3;iStep  ++){
#line 1501 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
BOOL bStepOK  = TRUE ;
#line 1503 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
en_vNextPosition  = en_plPlacement  . pl_PositionVector  + avTranslation  [ iStep  ];
#line 1504 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
en_mNextRotation  = en_mRotation ;
#line 1506 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
CClipMove  cm  (this );
#line 1507 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
en_pwoWorld  -> ClipMove  (cm );
#line 1510 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
if(cm  . cm_fMovementFraction  < 1.0f){
#line 1512 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
INDEX iSurfaceHit  = 0;
#line 1513 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
BOOL bHitStairsNow  = FALSE ;
#line 1514 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
if(cm  . cm_pbpoHit  != NULL ){
#line 1515 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
bHitStairsNow  = cm  . cm_pbpoHit  -> bpo_ulFlags  & BPOF_STAIRS ;
#line 1516 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
iSurfaceHit  = cm  . cm_pbpoHit  -> bpo_bppProperties  . bpp_ubSurfaceType ;
#line 1517 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
#line 1518 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
CSurfaceType  & stHit  = en_pwoWorld  -> wo_astSurfaceTypes  [ iSurfaceHit  ];
#line 1522 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
const FLOAT3D & vHitPlane  = cm  . cm_plClippedPlane ;
#line 1523 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
FLOAT fPlaneDotG  = vHitPlane  % en_vGravityDir ;
#line 1524 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
FLOAT fPlaneDotGAbs  = Abs  (fPlaneDotG );
#line 1526 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
BOOL bSlidingAllowed  = (fPlaneDotGAbs  > - 0.01f && fPlaneDotGAbs  < 0.99f) && bHitStairsOrg ;
#line 1528 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
BOOL bEarlyClipAllowed  = 
#line 1530 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
iStep  == 0 || 
#line 1532 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
(iStep  == 1 && bHitStairsNow ) || 
#line 1534 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
(iStep  == 2 && 
#line 1535 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
(vHitPlane  % en_vGravityDir  < - stHit  . st_fClimbSlopeCos  || 
#line 1536 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
bHitStairsNow ));
#line 1539 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
if(bEarlyClipAllowed  || bSlidingAllowed ){
#line 1541 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
en_vNextPosition  = en_plPlacement  . pl_PositionVector  + 
#line 1542 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
avTranslation  [ iStep  ] * (cm  . cm_fMovementFraction  * 0.98f);
#line 1543 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
if(bSlidingAllowed  && iStep  != 2){
#line 1544 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
FLOAT3D vSliding  = cm  . cm_plClippedPlane  . ProjectDirection  (
#line 1545 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
avTranslation  [ iStep  ] * (1.0f - cm  . cm_fMovementFraction )) + 
#line 1546 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
vHitPlane  * (ClampUp  (avTranslation  [ iStep  ] . Length  () , 0.5f) / 100.0f);
#line 1547 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
en_vNextPosition  += vSliding ;
#line 1548 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
#line 1549 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
CClipMove  cm  (this );
#line 1550 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
en_pwoWorld  -> ClipMove  (cm );
#line 1552 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
if(cm  . cm_fMovementFraction  <= 1.0f){
#line 1554 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
bStepOK  = FALSE ;
#line 1555 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
#line 1557 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}else {
#line 1559 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
bStepOK  = FALSE ;
#line 1560 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
#line 1561 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
#line 1564 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
if(bStepOK ){
#line 1566 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
SetPlacementFromNextPosition  ();
#line 1568 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}else {
#line 1570 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
en_vNextPosition  = plOriginal  . pl_PositionVector ;
#line 1571 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
SetPlacementFromNextPosition  ();
#line 1573 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
_pfPhysicsProfile  . StopTimer  ((INDEX) CPhysicsProfile  :: PTI_TRYTOGOUPSTAIRS );
#line 1575 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
return FALSE ;
#line 1576 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
#line 1578 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
#line 1584 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
if(! bGettingOutOfWater ){
#line 1585 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
en_vAppliedTranslation  += vTranslationHorizontalOrg ;
#line 1586 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
#line 1588 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
_pfPhysicsProfile  . StopTimer  ((INDEX) CPhysicsProfile  :: PTI_TRYTOGOUPSTAIRS );
#line 1590 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
return TRUE ;
#line 1591 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
  
#line 1594 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
BOOL CMovableEntity::TryToMove(CMovableEntity * penPusher,BOOL bTranslate,BOOL bRotate) 
#line 1595 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
{
#line 1598 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
if(penPusher  != NULL ){
#line 1599 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
_ctTryToMoveCheckCounter  --;
#line 1600 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}else {
#line 1601 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
_ctTryToMoveCheckCounter  -= 4;
#line 1602 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
#line 1604 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
if(_ctTryToMoveCheckCounter  < 0){
#line 1606 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
return FALSE ;
#line 1607 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
#line 1608 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
_pfPhysicsProfile  . StartTimer  ((INDEX) CPhysicsProfile  :: PTI_TRYTOTRANSLATE );
#line 1609 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
_pfPhysicsProfile  . IncrementTimerAveragingCounter  ((INDEX) CPhysicsProfile  :: PTI_TRYTOTRANSLATE );
#line 1610 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
_pfPhysicsProfile  . IncrementCounter  ((INDEX) CPhysicsProfile  :: PCI_TRYTOMOVE );
#line 1613 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
if(bTranslate ){
#line 1614 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
en_vNextPosition  = en_plPlacement  . pl_PositionVector  + en_vMoveTranslation ;
#line 1631 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}else {
#line 1632 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
en_vNextPosition  = en_plPlacement  . pl_PositionVector ;
#line 1633 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
#line 1634 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
if(bRotate ){
#line 1636 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
en_mNextRotation  = en_mMoveRotation  * en_mRotation ;
#line 1637 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}else {
#line 1638 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
en_mNextRotation  = en_mRotation ;
#line 1639 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
#line 1642 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
ULONG  ulCIFlags  = en_pciCollisionInfo  -> ci_ulFlags ;
#line 1643 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
BOOL bIgnoreRotation  = ! bRotate  || 
#line 1644 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
((ulCIFlags  & CIF_IGNOREROTATION ) || 
#line 1645 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
((ulCIFlags  & CIF_IGNOREHEADING ) && 
#line 1646 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
(en_mMoveRotation  (1 , 2) == 0 && en_mMoveRotation  (2 , 2) == 1 && en_mMoveRotation  (3 , 2) == 0)));
#line 1649 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
CClipMove  cmMove  (this );
#line 1651 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
if(! bTranslate  && bIgnoreRotation ){
#line 1652 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
cmMove  . cm_fMovementFraction  = 2.0f;
#line 1653 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
_pfPhysicsProfile  . IncrementCounter  ((INDEX) CPhysicsProfile  :: PCI_TRYTOMOVE_FAST );
#line 1654 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}else {
#line 1655 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
en_pwoWorld  -> ClipMove  (cmMove );
#line 1656 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
#line 1659 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
if(cmMove  . cm_fMovementFraction  > 1.0f){
#line 1663 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
if(bTranslate  && en_penReference  != NULL  && 
#line 1664 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
(en_ulPhysicsFlags  & EPF_TRANSLATEDBYGRAVITY ) && 
#line 1665 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
! (en_ulPhysicsFlags  & (EPF_ONSTEEPSLOPE  | EPF_ORIENTINGTOGRAVITY  | EPF_FLOATING )) && 
#line 1666 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
penPusher  == NULL  && WouldFallInNextPosition  ()){
#line 1668 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
SendEvent  (EWouldFall  ());
#line 1670 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
return FALSE ;
#line 1671 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
#line 1673 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
SetPlacementFromNextPosition  ();
#line 1674 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
if(bTranslate ){
#line 1675 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
en_vAppliedTranslation  += en_vMoveTranslation ;
#line 1676 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
#line 1677 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
if(bRotate ){
#line 1678 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
en_mAppliedRotation  = en_mMoveRotation  * en_mAppliedRotation ;
#line 1679 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
#line 1681 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
_pfPhysicsProfile  . IncrementCounter  ((INDEX) CPhysicsProfile  :: PCI_TRYTOMOVE_PASS );
#line 1682 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
_pfPhysicsProfile  . StopTimer  ((INDEX) CPhysicsProfile  :: PTI_TRYTOTRANSLATE );
#line 1684 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
return TRUE ;
#line 1687 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}else {
#line 1688 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
_pfPhysicsProfile  . IncrementCounter  ((INDEX) CPhysicsProfile  :: PCI_TRYTOMOVE_CLIP );
#line 1708 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
if(_ctTryToMoveCheckCounter  <= 0){
#line 1710 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
_pfPhysicsProfile  . StopTimer  ((INDEX) CPhysicsProfile  :: PTI_TRYTOTRANSLATE );
#line 1711 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
return FALSE ;
#line 1712 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
#line 1715 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
if(cmMove  . cm_pbpoHit  != NULL ){
#line 1717 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
if((cmMove  . cm_pbpoHit  -> bpo_ulFlags  & BPOF_STAIRS ) 
#line 1718 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
&& ((en_ulPhysicsFlags  & EPF_ONBLOCK_MASK ) == EPF_ONBLOCK_CLIMBORSLIDE )){
#line 1720 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
cmMove  . cm_plClippedPlane  = FLOATplane3D (- en_vGravityDir  , 0);
#line 1721 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
#line 1723 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
INDEX iSurface  = cmMove  . cm_pbpoHit  -> bpo_bppProperties  . bpp_ubSurfaceType ;
#line 1724 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
if(en_pwoWorld  -> wo_astSurfaceTypes  [ iSurface  ] . st_ulFlags  & STF_NOIMPACT ){
#line 1726 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
en_ulPhysicsFlags  |= EPF_NOIMPACTTHISTICK ;
#line 1727 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
#line 1728 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
#line 1732 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
if((en_ulPhysicsFlags  & EPF_TRANSLATEDBYGRAVITY ) && ! (en_ulPhysicsFlags  & EPF_FLOATING ) 
#line 1733 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
&& (
#line 1734 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
((en_vGravityDir  % (FLOAT3D &) cmMove  . cm_plClippedPlane ) 
#line 1735 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
< (en_vGravityDir  % en_vReferencePlane )))){
#line 1737 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
en_penReference  = cmMove  . cm_penHit ;
#line 1739 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
en_vReferencePlane  = (FLOAT3D &) cmMove  . cm_plClippedPlane ;
#line 1740 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
en_pbpoStandOn  = cmMove  . cm_pbpoHit ;
#line 1741 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
if(cmMove  . cm_pbpoHit  == NULL ){
#line 1742 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
en_iReferenceSurface  = 0;
#line 1743 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}else {
#line 1744 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
en_iReferenceSurface  = cmMove  . cm_pbpoHit  -> bpo_bppProperties  . bpp_ubSurfaceType ;
#line 1745 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
#line 1746 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
#line 1749 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
SendTouchEvent  (cmMove );
#line 1752 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
if(cmMove  . cm_penHit  -> en_ulPhysicsFlags  & EPF_NOIMPACT ){
#line 1754 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
en_ulPhysicsFlags  |= EPF_NOIMPACTTHISTICK ;
#line 1755 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
#line 1758 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
FLOAT3D vBounce ;
#line 1759 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
BOOL bBounce  = FALSE ;
#line 1760 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
if(((en_ulPhysicsFlags  & EPF_ONBLOCK_MASK ) == EPF_ONBLOCK_BOUNCE ) && bTranslate ){
#line 1762 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
FLOAT3D vParallel  , vNormal ;
#line 1763 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
GetParallelAndNormalComponents  (en_vMoveTranslation  , cmMove  . cm_plClippedPlane  , 
#line 1764 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
vNormal  , vParallel );
#line 1765 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
vNormal  *= - en_fBounceDampNormal ;
#line 1766 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
vParallel  *= + en_fBounceDampParallel ;
#line 1767 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
vBounce  = vNormal  + vParallel ;
#line 1769 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
if(vNormal  . Length  () > 0.1f){
#line 1771 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
bBounce  = TRUE ;
#line 1772 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
#line 1774 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
en_aDesiredRotationRelative  *= en_fBounceDampParallel ;
#line 1775 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
if(en_aDesiredRotationRelative  . Length  () < 10){
#line 1776 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
en_aDesiredRotationRelative  = ANGLE3D (0 , 0 , 0);
#line 1777 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
#line 1778 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
#line 1781 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
if(penPusher  != NULL  && (cmMove  . cm_penHit  -> en_ulPhysicsFlags  & EPF_PUSHABLE )){
#line 1782 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
CMovableModelEntity  * penBlocking  = ((CMovableModelEntity  *) cmMove  . cm_penHit );
#line 1784 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
FLOAT3D vRadius  = cmMove  . cm_penHit  -> en_plPlacement  . pl_PositionVector  - 
#line 1785 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
penPusher  -> en_plPlacement  . pl_PositionVector ;
#line 1786 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
FLOAT3D vPush  = (vRadius  * penPusher  -> en_mMoveRotation  - vRadius );
#line 1788 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
vPush  += penPusher  -> en_vMoveTranslation ;
#line 1791 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
penBlocking  -> en_vMoveTranslation  = vPush ;
#line 1792 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
penBlocking  -> en_mMoveRotation  = penPusher  -> en_mMoveRotation ;
#line 1795 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
penBlocking  -> AddToMoversDuringMoving  ();
#line 1797 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
_pfPhysicsProfile  . StopTimer  ((INDEX) CPhysicsProfile  :: PTI_TRYTOTRANSLATE );
#line 1798 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
BOOL bUnblocked  = penBlocking  -> TryToMove  (penPusher  , bTranslate  , bRotate );
#line 1799 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
_pfPhysicsProfile  . StartTimer  ((INDEX) CPhysicsProfile  :: PTI_TRYTOTRANSLATE );
#line 1801 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
if(bUnblocked ){
#line 1803 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
ClearNextPosition  ();
#line 1804 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
_pfPhysicsProfile  . StopTimer  ((INDEX) CPhysicsProfile  :: PTI_TRYTOTRANSLATE );
#line 1805 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
return TryToMove  (penPusher  , bTranslate  , bRotate );
#line 1806 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}else {
#line 1808 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
SendBlockEvent  (cmMove );
#line 1809 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
ClearNextPosition  ();
#line 1810 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
_pfPhysicsProfile  . StopTimer  ((INDEX) CPhysicsProfile  :: PTI_TRYTOTRANSLATE );
#line 1811 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
return FALSE ;
#line 1812 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
#line 1814 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}else if(
#line 1815 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
((en_ulPhysicsFlags  & EPF_ONBLOCK_MASK ) == EPF_ONBLOCK_SLIDE ) || 
#line 1816 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
((en_ulPhysicsFlags  & EPF_ONBLOCK_MASK ) == EPF_ONBLOCK_BOUNCE ) || 
#line 1817 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
((en_ulPhysicsFlags  & EPF_ONBLOCK_MASK ) == EPF_ONBLOCK_CLIMBORSLIDE ) || 
#line 1818 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
((en_ulPhysicsFlags  & EPF_ONBLOCK_MASK ) == EPF_ONBLOCK_STOPEXACT )){
#line 1821 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
if(bTranslate ){
#line 1824 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
FLOAT3D vSliding ;
#line 1826 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
if(_ctSliding  == 0){
#line 1828 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
_vSlideOffDir  = cmMove  . cm_plClippedPlane ;
#line 1830 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
vSliding  = cmMove  . cm_plClippedPlane  . ProjectDirection  (
#line 1831 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
en_vMoveTranslation  * (1.0f - cmMove  . cm_fMovementFraction ));
#line 1832 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
_ctSliding  ++;
#line 1834 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}else if(_ctSliding  == 1){
#line 1836 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
_vSlideOffDir  += cmMove  . cm_plClippedPlane ;
#line 1838 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
_vSlideDir  = _vSlideOffDir  * (FLOAT3D &) cmMove  . cm_plClippedPlane ;
#line 1839 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
if(_vSlideDir  . Length  () > 0.001f){
#line 1840 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
_vSlideDir  . Normalize  ();
#line 1841 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
#line 1842 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
_ctSliding  ++;
#line 1844 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
GetParallelComponent  (en_vMoveTranslation  * (1.0f - cmMove  . cm_fMovementFraction ) , 
#line 1845 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
_vSlideDir  , vSliding );
#line 1847 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}else {
#line 1849 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
_vSlideOffDir  += cmMove  . cm_plClippedPlane ;
#line 1851 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
_vSlideDir  = cmMove  . cm_plClippedPlane  . ProjectDirection  (_vSlideDir );
#line 1852 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
_ctSliding  ++;
#line 1854 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
GetParallelComponent  (en_vMoveTranslation  * (1.0f - cmMove  . cm_fMovementFraction ) , 
#line 1855 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
_vSlideDir  , vSliding );
#line 1856 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
#line 1857 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
ASSERT  (IsValidFloat  (vSliding  (1)));
#line 1858 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
ASSERT  (IsValidFloat  (_vSlideDir  (1)));
#line 1859 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
ASSERT  (IsValidFloat  (_vSlideOffDir  (1)));
#line 1862 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
if(cmMove  . cm_pbpoHit  != NULL ){
#line 1863 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
CSurfaceType  & stHit  = en_pwoWorld  -> wo_astSurfaceTypes  [ 
#line 1864 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
cmMove  . cm_pbpoHit  -> bpo_bppProperties  . bpp_ubSurfaceType  ];
#line 1866 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
if(penPusher  == NULL  
#line 1867 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
&& (en_ulPhysicsFlags  & EPF_ONBLOCK_MASK ) == EPF_ONBLOCK_CLIMBORSLIDE ){
#line 1875 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
FLOAT3D & vHitPlane  = (FLOAT3D &) cmMove  . cm_plClippedPlane ;
#line 1876 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
BOOL bHitStairs  = cmMove  . cm_pbpoHit  -> bpo_ulFlags  & BPOF_STAIRS ;
#line 1879 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
if((vHitPlane  % en_vGravityDir  > - stHit  . st_fClimbSlopeCos ) 
#line 1880 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
|| bHitStairs ){
#line 1883 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
FLOAT fSlidingVertical2  = en_vMoveTranslation  % en_vGravityDir ;
#line 1884 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
fSlidingVertical2  *= fSlidingVertical2 ;
#line 1885 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
FLOAT fSliding2  = en_vMoveTranslation  % en_vMoveTranslation ;
#line 1886 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
if((2 * fSlidingVertical2  <= fSliding2 ) 
#line 1888 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
&& TryToGoUpstairs  (en_vMoveTranslation  , stHit  , bHitStairs )){
#line 1890 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
_pfPhysicsProfile  . StopTimer  ((INDEX) CPhysicsProfile  :: PTI_TRYTOTRANSLATE );
#line 1891 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
return FALSE ;
#line 1892 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
#line 1893 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
#line 1894 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
#line 1895 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
#line 1897 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
if((en_ulPhysicsFlags  & EPF_ONBLOCK_MASK ) == EPF_ONBLOCK_STOPEXACT ){
#line 1899 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
vSliding  = FLOAT3D (0 , 0 , 0);
#line 1900 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
#line 1902 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
ASSERT  (IsValidFloat  (vSliding  (1)));
#line 1905 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
vSliding  += _vSlideOffDir  * 
#line 1906 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
(ClampUp  (en_vMoveTranslation  . Length  () , 0.5f) / 100.0f);
#line 1909 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
if(en_vMoveTranslation  . Length  () > 0.001f && cmMove  . cm_fMovementFraction  > 0.002f){
#line 1911 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
vSliding  += en_vMoveTranslation  * (cmMove  . cm_fMovementFraction  * 0.98f);
#line 1912 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
#line 1915 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
if(vSliding  . ManhattanNorm  () < 0.001f){
#line 1916 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
_pfPhysicsProfile  . StopTimer  ((INDEX) CPhysicsProfile  :: PTI_TRYTOTRANSLATE );
#line 1917 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
return FALSE ;
#line 1918 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
#line 1921 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
en_vMoveTranslation  = vSliding ;
#line 1922 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
ClearNextPosition  ();
#line 1923 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
_pfPhysicsProfile  . StopTimer  ((INDEX) CPhysicsProfile  :: PTI_TRYTOTRANSLATE );
#line 1924 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
TryToMove  (penPusher  , bTranslate  , bRotate );
#line 1926 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
if(bBounce ){
#line 1928 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
en_vAppliedTranslation  = vBounce ;
#line 1930 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
en_penReference  = NULL ;
#line 1931 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
en_vReferencePlane  = FLOAT3D (0.0f , 0.0f , 0.0f);
#line 1932 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
en_iReferenceSurface  = 0;
#line 1933 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
#line 1936 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
return FALSE ;
#line 1939 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}else if(bRotate ){
#line 1941 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
if((en_ulPhysicsFlags  & EPF_ONBLOCK_MASK ) == EPF_ONBLOCK_BOUNCE ){
#line 1943 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
en_aDesiredRotationRelative  *= en_fBounceDampParallel ;
#line 1944 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
if(en_aDesiredRotationRelative  . Length  () < 10){
#line 1945 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
en_aDesiredRotationRelative  = ANGLE3D (0 , 0 , 0);
#line 1946 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
#line 1947 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
_pfPhysicsProfile  . StopTimer  ((INDEX) CPhysicsProfile  :: PTI_TRYTOTRANSLATE );
#line 1949 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
return FALSE ;
#line 1950 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
#line 1952 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
en_vMoveTranslation  = cmMove  . cm_vClippedLine  * - 1.2f;
#line 1954 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
ClearNextPosition  ();
#line 1955 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
_pfPhysicsProfile  . StopTimer  ((INDEX) CPhysicsProfile  :: PTI_TRYTOTRANSLATE );
#line 1956 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
TryToMove  (penPusher  , TRUE  , bRotate );
#line 1958 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
return FALSE ;
#line 1959 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
#line 1961 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
_pfPhysicsProfile  . StopTimer  ((INDEX) CPhysicsProfile  :: PTI_TRYTOTRANSLATE );
#line 1962 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
return FALSE ;
#line 1965 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}else {
#line 1967 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
SendBlockEvent  (cmMove );
#line 1968 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
ClearNextPosition  ();
#line 1969 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
_pfPhysicsProfile  . StopTimer  ((INDEX) CPhysicsProfile  :: PTI_TRYTOTRANSLATE );
#line 1970 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
return FALSE ;
#line 1971 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
#line 1972 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
#line 1973 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
  void CMovableEntity::ClearMovingTemp(void) 
#line 1997 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
{
#line 2001 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
ClearNextPosition  ();
#line 2002 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
CLEARMEM  (en_vMoveTranslation );
#line 2003 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
CLEARMEM  (en_mMoveRotation );
#line 2004 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
CLEARMEM  (en_vAppliedTranslation );
#line 2005 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
CLEARMEM  (en_mAppliedRotation );
#line 2006 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
  void CMovableEntity::PreMoving(void) 
#line 2010 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
{
#line 2019 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
if(_pNetwork  -> ga_ulDemoMinorVersion  <= 5){
#line 2020 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
PreMovingOld  ();
#line 2021 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}else {
#line 2022 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
PreMovingNew  ();
#line 2023 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
#line 2024 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
  
#line 2025 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
void CMovableEntity::PreMovingNew(void) 
#line 2026 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
{
#line 2027 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
if(en_pciCollisionInfo  == NULL ){
#line 2028 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
return ;
#line 2029 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
#line 2035 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
_pfPhysicsProfile  . StartTimer  ((INDEX) CPhysicsProfile  :: PTI_PREMOVING );
#line 2036 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
_pfPhysicsProfile  . IncrementTimerAveragingCounter  ((INDEX) CPhysicsProfile  :: PTI_PREMOVING );
#line 2039 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
en_plLastPlacement  = en_plPlacement ;
#line 2042 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
{FOREACHINLIST  (CEntity  , en_lnInParent  , en_lhChildren  , itenChild ){
#line 2044 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
if((itenChild  -> en_ulPhysicsFlags  & EPF_MOVABLE ) 
#line 2045 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
&& ! ((CMovableEntity  *) & * itenChild ) -> en_lnInMovers  . IsLinked  ()){
#line 2046 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
CMovableEntity  * penChild  = ((CMovableEntity  *) & * itenChild );
#line 2048 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
penChild  -> en_plLastPlacement  = penChild  -> en_plPlacement ;
#line 2049 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
#line 2050 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}}
#line 2052 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
FLOAT fTickQuantum  = _pTimer  -> TickQuantum ;
#line 2055 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
if(dbg_bBreak ){
#line 2056 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
dbg_bBreak  = FALSE ;
#line 2057 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
try {
#line 2058 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
Breakpoint  ();
#line 2059 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}catch  (ANYEXCEPTION ){
#line 2060 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
CPrintF  ("Breakpoint!\n");
#line 2061 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
};
#line 2062 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
#line 2070 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
const FLOAT fMaxSpeed  = 300.0f;
#line 2071 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
en_vCurrentTranslationAbsolute  (1) = Clamp  (en_vCurrentTranslationAbsolute  (1) , - fMaxSpeed  , + fMaxSpeed );
#line 2072 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
en_vCurrentTranslationAbsolute  (2) = Clamp  (en_vCurrentTranslationAbsolute  (2) , - fMaxSpeed  , + fMaxSpeed );
#line 2073 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
en_vCurrentTranslationAbsolute  (3) = Clamp  (en_vCurrentTranslationAbsolute  (3) , - fMaxSpeed  , + fMaxSpeed );
#line 2076 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
if(en_RenderType  == RT_MODEL  || en_RenderType  == RT_EDITORMODEL  || 
#line 2077 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
en_RenderType  == RT_SKAMODEL  || en_RenderType  == RT_SKAEDITORMODEL ){
#line 2079 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
TestFields  (en_iUpContent  , en_iDnContent  , en_fImmersionFactor );
#line 2081 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
if(en_ulPhysicsFlags  & EPF_STICKYFEET ){
#line 2083 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
FLOAT3D vPoint ;
#line 2084 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
FLOATplane3D plPlane ;
#line 2085 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
FLOAT fDistanceToEdge ;
#line 2086 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
if(GetNearestPolygon  (vPoint  , plPlane  , fDistanceToEdge )){
#line 2087 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
en_vGravityDir  = - (FLOAT3D &) plPlane ;
#line 2088 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
#line 2089 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
#line 2090 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
#line 2091 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
CContentType  & ctDn  = en_pwoWorld  -> wo_actContentTypes  [ en_iDnContent  ];
#line 2092 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
CContentType  & ctUp  = en_pwoWorld  -> wo_actContentTypes  [ en_iUpContent  ];
#line 2095 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
TestBreathing  (ctUp );
#line 2097 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
TestContentDamage  (ctDn  , en_fImmersionFactor );
#line 2099 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
if(en_penReference  != NULL ){
#line 2100 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
CSurfaceType  & stReference  = en_pwoWorld  -> wo_astSurfaceTypes  [ en_iReferenceSurface  ];
#line 2101 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
TestSurfaceDamage  (stReference );
#line 2102 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
#line 2105 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
FLOAT fBouyancy  = (1 - 
#line 2106 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
(ctDn  . ct_fDensity  / en_fDensity ) * en_fImmersionFactor  - 
#line 2107 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
(ctUp  . ct_fDensity  / en_fDensity ) * (1 - en_fImmersionFactor ));
#line 2108 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
FLOAT fSpeedModifier  = 
#line 2109 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
ctDn  . ct_fSpeedMultiplier  * en_fImmersionFactor  + 
#line 2110 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
ctUp  . ct_fSpeedMultiplier  * (1 - en_fImmersionFactor );
#line 2111 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
FLOAT fFluidFriction  = 
#line 2112 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
ctDn  . ct_fFluidFriction  * en_fImmersionFactor  + 
#line 2113 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
ctUp  . ct_fFluidFriction  * (1 - en_fImmersionFactor );
#line 2114 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
FLOAT fControlMultiplier  = 
#line 2115 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
ctDn  . ct_fControlMultiplier  * en_fImmersionFactor  + 
#line 2116 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
ctUp  . ct_fControlMultiplier  * (1 - en_fImmersionFactor );
#line 2119 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
FLOAT3D vDesiredTranslationAbsolute  = en_vDesiredTranslationRelative ;
#line 2121 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
if(! (en_ulPhysicsFlags  & EPF_ABSOLUTETRANSLATE )){
#line 2122 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
vDesiredTranslationAbsolute  *= en_mRotation ;
#line 2123 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
#line 2125 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
vDesiredTranslationAbsolute  *= fTickQuantum ;
#line 2126 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
ANGLE3D aRotationRelative ;
#line 2127 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
aRotationRelative  (1) = en_aDesiredRotationRelative  (1) * fTickQuantum ;
#line 2128 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
aRotationRelative  (2) = en_aDesiredRotationRelative  (2) * fTickQuantum ;
#line 2129 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
aRotationRelative  (3) = en_aDesiredRotationRelative  (3) * fTickQuantum ;
#line 2131 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
FLOATmatrix3D mRotationAbsolute ;
#line 2133 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
if((en_ulPhysicsFlags  & EPF_ONBLOCK_MASK ) == EPF_ONBLOCK_PUSH ){
#line 2134 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
FLOATmatrix3D mNewRotation ;
#line 2135 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
MakeRotationMatrixFast  (mNewRotation  , en_plPlacement  . pl_OrientationAngle  + aRotationRelative );
#line 2136 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
mRotationAbsolute  = mNewRotation  * ! en_mRotation ;
#line 2138 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}else {
#line 2139 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
MakeRotationMatrixFast  (mRotationAbsolute  , aRotationRelative );
#line 2140 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
mRotationAbsolute  = en_mRotation  * (mRotationAbsolute  * ! en_mRotation );
#line 2141 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
#line 2144 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
vDesiredTranslationAbsolute  *= fSpeedModifier ;
#line 2147 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
FLOAT fJump  = - en_mRotation  . GetColumn  (2) % vDesiredTranslationAbsolute ;
#line 2149 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
BOOL bReferenceMovingInY  = FALSE ;
#line 2150 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
BOOL bReferenceRotatingNonY  = FALSE ;
#line 2152 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
if(en_penReference  != NULL  && (en_penReference  -> en_ulPhysicsFlags  & EPF_MOVABLE )){
#line 2153 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
CMovableEntity  * penReference  = (CMovableEntity  *) (CEntity  *) en_penReference ;
#line 2155 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
const FLOAT3D & vReferenceTranslation  = penReference  -> en_vIntendedTranslation ;
#line 2156 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
const FLOATmatrix3D & mReferenceRotation  = penReference  -> en_mIntendedRotation ;
#line 2158 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
FLOAT3D vRadius  = en_plPlacement  . pl_PositionVector  
#line 2159 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
- penReference  -> en_plPlacement  . pl_PositionVector ;
#line 2160 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
FLOAT3D vReferenceDelta  = vReferenceTranslation  + vRadius  * mReferenceRotation  - vRadius ;
#line 2162 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
vDesiredTranslationAbsolute  += vReferenceDelta ;
#line 2163 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
mRotationAbsolute  = mReferenceRotation  * mRotationAbsolute ;
#line 2166 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
bReferenceMovingInY  = (vReferenceDelta  % en_vGravityDir  != 0.0f);
#line 2167 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
bReferenceRotatingNonY  = ((en_vGravityDir  * mReferenceRotation ) % en_vGravityDir ) > 0.01f;
#line 2168 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
#line 2170 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
FLOAT3D vTranslationAbsolute  = en_vCurrentTranslationAbsolute  * fTickQuantum ;
#line 2173 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
en_ulPhysicsFlags  &= ~ EPF_ORIENTINGTOGRAVITY ;
#line 2175 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
if(en_ulPhysicsFlags  & EPF_ORIENTEDBYGRAVITY ){
#line 2177 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
FLOAT3D vDown ;
#line 2178 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
vDown  (1) = - en_mRotation  (1 , 2);
#line 2179 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
vDown  (2) = - en_mRotation  (2 , 2);
#line 2180 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
vDown  (3) = - en_mRotation  (3 , 2);
#line 2183 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
FLOAT fCos  = vDown  % en_vGravityDir ;
#line 2185 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
if(fCos  < 0.99999f){
#line 2187 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
en_ulPhysicsFlags  |= EPF_ORIENTINGTOGRAVITY ;
#line 2190 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
ANGLE a  = ACos  (fCos );
#line 2191 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
if(Abs  (a ) > 20){
#line 2192 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
a  = 20 * Sgn  (a );
#line 2193 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
#line 2194 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
FLOAT fRad  = RadAngle  (a );
#line 2197 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
FLOAT3D vAxis  = vDown  * en_vGravityDir ;
#line 2198 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
FLOAT fLen  = vAxis  . Length  ();
#line 2199 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
if(fLen  < 0.01f){
#line 2200 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
vAxis  (1) = en_mRotation  (1 , 3);
#line 2201 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
vAxis  (2) = en_mRotation  (2 , 3);
#line 2202 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
vAxis  (3) = en_mRotation  (3 , 3);
#line 2205 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}else if(! bReferenceRotatingNonY ){
#line 2206 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
fRad  /= fLen ;
#line 2207 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
#line 2208 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
vAxis  *= fRad ;
#line 2211 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
FLOATmatrix3D mGRotation ;
#line 2212 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
mGRotation  (1 , 1) = 1;mGRotation  (1 , 2) = - vAxis  (3);mGRotation  (1 , 3) = vAxis  (2);
#line 2213 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
mGRotation  (2 , 1) = vAxis  (3);mGRotation  (2 , 2) = 1;mGRotation  (2 , 3) = - vAxis  (1);
#line 2214 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
mGRotation  (3 , 1) = - vAxis  (2);mGRotation  (3 , 2) = vAxis  (1);mGRotation  (3 , 3) = 1;
#line 2215 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
OrthonormalizeRotationMatrix  (mGRotation );
#line 2218 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
mRotationAbsolute  = mGRotation  * mRotationAbsolute ;
#line 2219 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
#line 2220 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
#line 2223 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
en_ulPhysicsFlags  &= ~ EPF_FLOATING ;
#line 2225 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
FLOAT ACC  = en_fAcceleration  * fTickQuantum  * fTickQuantum ;
#line 2226 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
FLOAT DEC  = en_fDeceleration  * fTickQuantum  * fTickQuantum ;
#line 2228 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
if(! (en_ulPhysicsFlags  & EPF_TRANSLATEDBYGRAVITY )){
#line 2230 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
if(en_ulPhysicsFlags  & EPF_NOACCELERATION ){
#line 2231 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
vTranslationAbsolute  = vDesiredTranslationAbsolute ;
#line 2232 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}else {
#line 2233 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
AddAcceleration  (vTranslationAbsolute  , vDesiredTranslationAbsolute  , 
#line 2234 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
ACC  * fControlMultiplier  , 
#line 2235 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
DEC  * fControlMultiplier );
#line 2236 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
#line 2238 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}else if((fBouyancy  * en_fGravityA  < 0.5f && (ctDn  . ct_ulFlags  & (CTF_SWIMABLE  | CTF_FLYABLE )))){
#line 2240 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
en_ulPhysicsFlags  |= EPF_FLOATING ;
#line 2242 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
if(en_ulPhysicsFlags  & EPF_NOACCELERATION ){
#line 2243 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
vTranslationAbsolute  = vDesiredTranslationAbsolute ;
#line 2244 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}else {
#line 2245 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
AddAcceleration  (vTranslationAbsolute  , vDesiredTranslationAbsolute  , 
#line 2246 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
ACC  * fControlMultiplier  , 
#line 2247 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
DEC  * fControlMultiplier );
#line 2248 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
#line 2251 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
if(fBouyancy  < - 0.1f){
#line 2252 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
FLOAT fGV  = en_fGravityV  * fTickQuantum  * fSpeedModifier ;
#line 2253 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
FLOAT fGA  = (en_fGravityA  * - fBouyancy ) * fTickQuantum  * fTickQuantum ;
#line 2254 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
AddAcceleration  (vTranslationAbsolute  , en_vGravityDir  * - fGV  , fGA  , fGA );
#line 2255 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}else if(fBouyancy  > + 0.1f){
#line 2256 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
FLOAT fGV  = en_fGravityV  * fTickQuantum  * fSpeedModifier ;
#line 2257 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
FLOAT fGA  = (en_fGravityA  * fBouyancy ) * fTickQuantum  * fTickQuantum ;
#line 2258 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
AddAcceleration  (vTranslationAbsolute  , en_vGravityDir  * fGV  , fGA  , fGA );
#line 2259 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
#line 2262 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}else {
#line 2263 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
BOOL bGravityAlongPolygon  = TRUE ;
#line 2265 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
if(en_pbpoStandOn  == NULL  || ! IsStandingOnPolygon  (en_pbpoStandOn ) || bReferenceMovingInY  
#line 2266 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
|| (en_ulPhysicsFlags  & EPF_ORIENTINGTOGRAVITY )){
#line 2268 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
en_pbpoStandOn  = NULL ;
#line 2269 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
if(en_penReference  == NULL  || bReferenceMovingInY ){
#line 2270 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
bGravityAlongPolygon  = FALSE ;
#line 2271 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
#line 2272 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
#line 2275 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
if(! bGravityAlongPolygon ){
#line 2276 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
_pfPhysicsProfile  . IncrementCounter  ((INDEX) CPhysicsProfile  :: PCI_GRAVITY_NONTRIVIAL );
#line 2279 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
FLOAT fGV  = en_fGravityV  * fTickQuantum  * fSpeedModifier ;
#line 2280 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
FLOAT fGA  = (en_fGravityA  * fBouyancy ) * fTickQuantum  * fTickQuantum ;
#line 2281 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
AddGAcceleration  (vTranslationAbsolute  , en_vGravityDir  , fGA  , fGV );
#line 2283 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}else {
#line 2284 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
_pfPhysicsProfile  . IncrementCounter  ((INDEX) CPhysicsProfile  :: PCI_GRAVITY_TRIVIAL );
#line 2287 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
FLOAT3D vPolygonDir  = - en_vReferencePlane ;
#line 2289 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
FLOAT3D vGParallel  , vGNormal ;
#line 2290 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
GetParallelAndNormalComponents  (en_vGravityDir  , vPolygonDir  , vGNormal  , vGParallel );
#line 2292 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
FLOAT fFactor  = vGParallel  . Length  ();
#line 2294 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
if(fFactor  > 0.001f){
#line 2295 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
FLOAT fGV  = en_fGravityV  * fTickQuantum  * fSpeedModifier ;
#line 2296 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
FLOAT fGA  = (en_fGravityA  * fBouyancy ) * fTickQuantum  * fTickQuantum ;
#line 2297 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
AddGAcceleration  (vTranslationAbsolute  , vGParallel  / fFactor  , fGA  * fFactor  , fGV  * fFactor );
#line 2298 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
#line 2301 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
FLOAT fPolyGA  = (vPolygonDir  % en_vGravityDir ) * en_fGravityA ;
#line 2302 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
FLOAT fYSpeed  = vPolygonDir  % vTranslationAbsolute ;
#line 2303 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
if(fYSpeed  > 0 && fYSpeed  < fPolyGA ){
#line 2304 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
vTranslationAbsolute  -= vPolygonDir  * fYSpeed ;
#line 2305 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
#line 2308 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
if((en_ulPhysicsFlags  & EPF_ONBLOCK_MASK ) == EPF_ONBLOCK_BOUNCE ){
#line 2310 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
en_aDesiredRotationRelative  *= en_fJumpControlMultiplier ;
#line 2311 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
if(en_aDesiredRotationRelative  . Length  () < 10){
#line 2312 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
en_aDesiredRotationRelative  = ANGLE3D (0 , 0 , 0);
#line 2313 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
#line 2314 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
#line 2315 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
#line 2317 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
CSurfaceType  & stReference  = en_pwoWorld  -> wo_astSurfaceTypes  [ en_iReferenceSurface  ];
#line 2320 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
if(en_penReference  != NULL ){
#line 2321 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
FLOAT fPlaneY  = (en_vGravityDir  % en_vReferencePlane );
#line 2322 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
FLOAT fPlaneYAbs  = Abs  (fPlaneY );
#line 2323 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
FLOAT fFriction  = stReference  . st_fFriction ;
#line 2325 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
if((fPlaneY  >= - stReference  . st_fClimbSlopeCos  && fPlaneY  < 0) 
#line 2326 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
|| ((stReference  . st_ulFlags  & STF_SLIDEDOWNSLOPE ) && fPlaneY  > - 0.99f)){
#line 2327 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
en_ulPhysicsFlags  |= EPF_ONSTEEPSLOPE ;
#line 2329 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
AddAccelerationOnPlane2  (
#line 2330 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
vTranslationAbsolute  , 
#line 2331 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
vDesiredTranslationAbsolute  , 
#line 2332 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
ACC  * fPlaneYAbs  * fPlaneYAbs  * fFriction  * fControlMultiplier  , 
#line 2333 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
DEC  * fPlaneYAbs  * fPlaneYAbs  * fFriction  * fControlMultiplier  , 
#line 2334 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
en_vReferencePlane  , 
#line 2335 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
en_vGravityDir );
#line 2337 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}else {
#line 2338 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
en_ulPhysicsFlags  &= ~ EPF_ONSTEEPSLOPE ;
#line 2340 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
AddAccelerationOnPlane  (
#line 2341 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
vTranslationAbsolute  , 
#line 2342 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
vDesiredTranslationAbsolute  , 
#line 2343 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
ACC  * fPlaneYAbs  * fPlaneYAbs  * fFriction  * fControlMultiplier  , 
#line 2344 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
DEC  * fPlaneYAbs  * fPlaneYAbs  * fFriction  * fControlMultiplier  , 
#line 2345 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
en_vReferencePlane );
#line 2346 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
#line 2348 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
if(fJump  < - 0.01f && (fPlaneY  < - stReference  . st_fJumpSlopeCos  
#line 2349 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
|| _pTimer  -> CurrentTick  () > en_tmLastSignificantVerticalMovement  + 0.25f)){
#line 2351 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
vTranslationAbsolute  += en_vGravityDir  * fJump ;
#line 2352 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
en_tmJumped  = _pTimer  -> CurrentTick  ();
#line 2353 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
en_pbpoStandOn  = NULL ;
#line 2354 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
#line 2357 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}else {
#line 2359 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
if(_pTimer  -> CurrentTick  () - en_tmJumped  < en_tmMaxJumpControl ){
#line 2361 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
AddAccelerationOnPlane  (
#line 2362 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
vTranslationAbsolute  , 
#line 2363 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
vDesiredTranslationAbsolute  , 
#line 2364 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
ACC  * fControlMultiplier  * en_fJumpControlMultiplier  , 
#line 2365 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
DEC  * fControlMultiplier  * en_fJumpControlMultiplier  , 
#line 2366 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
FLOATplane3D (en_vGravityDir  , 0));
#line 2367 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
#line 2370 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
if(fJump  < - 0.01f && 
#line 2371 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
_pTimer  -> CurrentTick  () > en_tmLastSignificantVerticalMovement  + 0.25f){
#line 2373 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
vTranslationAbsolute  += en_vGravityDir  * fJump ;
#line 2374 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
en_tmJumped  = _pTimer  -> CurrentTick  ();
#line 2375 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
en_pbpoStandOn  = NULL ;
#line 2376 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
#line 2377 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
#line 2378 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
#line 2382 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
CheckAndAddGAcceleration  (this  , vTranslationAbsolute  , fTickQuantum );
#line 2385 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
if(fFluidFriction  > 0.01f){
#line 2387 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
AddAcceleration  (vTranslationAbsolute  , FLOAT3D (0.0f , 0.0f , 0.0f) , 
#line 2388 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
0.0f , DEC  * fFluidFriction );
#line 2389 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
#line 2392 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
if((en_ulPhysicsFlags  & EPF_CANFADESPINNING ) && 
#line 2393 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
((ctDn  . ct_ulFlags  & CTF_FADESPINNING ) || (ctUp  . ct_ulFlags  & CTF_FADESPINNING ))){
#line 2395 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
en_aDesiredRotationRelative  *= (1 - fSpeedModifier  * 0.05f);
#line 2396 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
if(en_aDesiredRotationRelative  . Length  () < 10){
#line 2397 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
en_aDesiredRotationRelative  = ANGLE3D (0 , 0 , 0);
#line 2398 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
#line 2399 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
#line 2402 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
if(en_pbpoStandOn  == NULL  && (vTranslationAbsolute  . ManhattanNorm  () > 1E-5f || 
#line 2403 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
en_vReferencePlane  % en_vGravityDir  < 0.0f)){
#line 2404 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
en_penReference  = NULL ;
#line 2405 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
en_vReferencePlane  = FLOAT3D (0.0f , 0.0f , 0.0f);
#line 2406 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
en_iReferenceSurface  = 0;
#line 2407 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
#line 2409 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
en_vIntendedTranslation  = vTranslationAbsolute ;
#line 2410 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
en_mIntendedRotation  = mRotationAbsolute ;
#line 2415 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
FLOATaabbox3D box ;
#line 2416 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
en_pciCollisionInfo  -> MakeBoxAtPlacement  (FLOAT3D (0 , 0 , 0) , en_mRotation  , box );
#line 2418 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
{CLightSource  * pls  = GetLightSource  ();
#line 2419 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
if(pls  != NULL  && ! (pls  -> ls_ulFlags  & LSF_LENSFLAREONLY )){
#line 2421 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
ASSERT  (! (pls  -> ls_ulFlags  & LSF_DIRECTIONAL ));
#line 2422 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
box  |= FLOATaabbox3D (FLOAT3D (0 , 0 , 0) , pls  -> ls_rFallOff );
#line 2423 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}}
#line 2425 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
box  . ExpandByFactor  (phy_fCollisionCacheAround  - 1.0f);
#line 2427 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
box  += en_plPlacement  . pl_PositionVector ;
#line 2428 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
en_boxMovingEstimate  = box ;
#line 2429 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
box  += en_vIntendedTranslation  * phy_fCollisionCacheAhead ;
#line 2430 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
en_boxMovingEstimate  |= box ;
#line 2433 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
en_vAppliedTranslation  = FLOAT3D (0.0f , 0.0f , 0.0f);
#line 2434 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
en_mAppliedRotation  . Diagonal  (1.0f);
#line 2435 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
_pfPhysicsProfile  . StopTimer  ((INDEX) CPhysicsProfile  :: PTI_PREMOVING );
#line 2437 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
  
#line 2441 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
void CMovableEntity::PreMovingOld(void) 
#line 2442 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
{
#line 2443 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
if(en_pciCollisionInfo  == NULL ){
#line 2444 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
return ;
#line 2445 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
#line 2451 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
_pfPhysicsProfile  . StartTimer  (CPhysicsProfile  :: PTI_PREMOVING );
#line 2452 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
_pfPhysicsProfile  . IncrementTimerAveragingCounter  (CPhysicsProfile  :: PTI_PREMOVING );
#line 2455 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
en_plLastPlacement  = en_plPlacement ;
#line 2458 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
{FOREACHINLIST  (CEntity  , en_lnInParent  , en_lhChildren  , itenChild ){
#line 2460 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
if((itenChild  -> en_ulPhysicsFlags  & EPF_MOVABLE ) 
#line 2461 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
&& ! ((CMovableEntity  *) & * itenChild ) -> en_lnInMovers  . IsLinked  ()){
#line 2462 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
CMovableEntity  * penChild  = ((CMovableEntity  *) & * itenChild );
#line 2464 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
penChild  -> en_plLastPlacement  = penChild  -> en_plPlacement ;
#line 2465 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
#line 2466 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}}
#line 2468 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
FLOAT fTickQuantum  = _pTimer  -> TickQuantum ;
#line 2471 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
if(dbg_bBreak ){
#line 2472 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
dbg_bBreak  = FALSE ;
#line 2473 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
try {
#line 2474 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
Breakpoint  ();
#line 2475 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}catch  (ANYEXCEPTION ){
#line 2476 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
CPrintF  ("Breakpoint!\n");
#line 2477 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
};
#line 2478 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
#line 2486 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
const FLOAT fMaxSpeed  = 300.0f;
#line 2487 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
en_vCurrentTranslationAbsolute  (1) = Clamp  (en_vCurrentTranslationAbsolute  (1) , - fMaxSpeed  , + fMaxSpeed );
#line 2488 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
en_vCurrentTranslationAbsolute  (2) = Clamp  (en_vCurrentTranslationAbsolute  (2) , - fMaxSpeed  , + fMaxSpeed );
#line 2489 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
en_vCurrentTranslationAbsolute  (3) = Clamp  (en_vCurrentTranslationAbsolute  (3) , - fMaxSpeed  , + fMaxSpeed );
#line 2492 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
if(en_RenderType  == RT_MODEL  || en_RenderType  == RT_EDITORMODEL ){
#line 2494 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
TestFields  (en_iUpContent  , en_iDnContent  , en_fImmersionFactor );
#line 2496 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
if(en_ulPhysicsFlags  & EPF_STICKYFEET ){
#line 2498 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
FLOAT3D vPoint ;
#line 2499 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
FLOATplane3D plPlane ;
#line 2500 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
FLOAT fDistanceToEdge ;
#line 2501 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
if(GetNearestPolygon  (vPoint  , plPlane  , fDistanceToEdge )){
#line 2502 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
en_vGravityDir  = - (FLOAT3D &) plPlane ;
#line 2503 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
#line 2504 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
#line 2505 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
#line 2506 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
CContentType  & ctDn  = en_pwoWorld  -> wo_actContentTypes  [ en_iDnContent  ];
#line 2507 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
CContentType  & ctUp  = en_pwoWorld  -> wo_actContentTypes  [ en_iUpContent  ];
#line 2510 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
TestBreathing  (ctUp );
#line 2512 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
TestContentDamage  (ctDn  , en_fImmersionFactor );
#line 2514 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
if(en_penReference  != NULL ){
#line 2515 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
CSurfaceType  & stReference  = en_pwoWorld  -> wo_astSurfaceTypes  [ en_iReferenceSurface  ];
#line 2516 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
TestSurfaceDamage  (stReference );
#line 2517 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
#line 2520 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
FLOAT fBouyancy  = (1 - 
#line 2521 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
(ctDn  . ct_fDensity  / en_fDensity ) * en_fImmersionFactor  - 
#line 2522 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
(ctUp  . ct_fDensity  / en_fDensity ) * (1 - en_fImmersionFactor ));
#line 2523 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
FLOAT fSpeedModifier  = 
#line 2524 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
ctDn  . ct_fSpeedMultiplier  * en_fImmersionFactor  + 
#line 2525 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
ctUp  . ct_fSpeedMultiplier  * (1 - en_fImmersionFactor );
#line 2526 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
FLOAT fFluidFriction  = 
#line 2527 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
ctDn  . ct_fFluidFriction  * en_fImmersionFactor  + 
#line 2528 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
ctUp  . ct_fFluidFriction  * (1 - en_fImmersionFactor );
#line 2529 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
FLOAT fControlMultiplier  = 
#line 2530 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
ctDn  . ct_fControlMultiplier  * en_fImmersionFactor  + 
#line 2531 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
ctUp  . ct_fControlMultiplier  * (1 - en_fImmersionFactor );
#line 2534 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
FLOAT3D vDesiredTranslationAbsolute  = en_vDesiredTranslationRelative ;
#line 2536 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
if(! (en_ulPhysicsFlags  & EPF_ABSOLUTETRANSLATE )){
#line 2537 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
vDesiredTranslationAbsolute  *= en_mRotation ;
#line 2538 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
#line 2540 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
vDesiredTranslationAbsolute  *= fTickQuantum ;
#line 2541 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
ANGLE3D aRotationRelative ;
#line 2542 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
aRotationRelative  (1) = en_aDesiredRotationRelative  (1) * fTickQuantum ;
#line 2543 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
aRotationRelative  (2) = en_aDesiredRotationRelative  (2) * fTickQuantum ;
#line 2544 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
aRotationRelative  (3) = en_aDesiredRotationRelative  (3) * fTickQuantum ;
#line 2546 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
FLOATmatrix3D mRotationAbsolute ;
#line 2548 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
if((en_ulPhysicsFlags  & EPF_ONBLOCK_MASK ) == EPF_ONBLOCK_PUSH ){
#line 2549 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
FLOATmatrix3D mNewRotation ;
#line 2550 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
MakeRotationMatrixFast  (mNewRotation  , en_plPlacement  . pl_OrientationAngle  + aRotationRelative );
#line 2551 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
mRotationAbsolute  = mNewRotation  * ! en_mRotation ;
#line 2553 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}else {
#line 2554 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
MakeRotationMatrixFast  (mRotationAbsolute  , aRotationRelative );
#line 2555 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
mRotationAbsolute  = en_mRotation  * (mRotationAbsolute  * ! en_mRotation );
#line 2556 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
#line 2559 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
vDesiredTranslationAbsolute  *= fSpeedModifier ;
#line 2562 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
FLOAT fJump  = - en_mRotation  . GetColumn  (2) % vDesiredTranslationAbsolute ;
#line 2564 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
BOOL bReferenceMovingInY  = FALSE ;
#line 2565 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
BOOL bReferenceRotatingNonY  = FALSE ;
#line 2567 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
if(en_penReference  != NULL  && (en_penReference  -> en_ulPhysicsFlags  & EPF_MOVABLE )){
#line 2568 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
CMovableEntity  * penReference  = (CMovableEntity  *) (CEntity  *) en_penReference ;
#line 2570 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
const FLOAT3D & vReferenceTranslation  = penReference  -> en_vIntendedTranslation ;
#line 2571 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
const FLOATmatrix3D & mReferenceRotation  = penReference  -> en_mIntendedRotation ;
#line 2573 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
FLOAT3D vRadius  = en_plPlacement  . pl_PositionVector  
#line 2574 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
- penReference  -> en_plPlacement  . pl_PositionVector ;
#line 2575 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
FLOAT3D vReferenceDelta  = vReferenceTranslation  + vRadius  * mReferenceRotation  - vRadius ;
#line 2577 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
vDesiredTranslationAbsolute  += vReferenceDelta ;
#line 2578 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
mRotationAbsolute  = mReferenceRotation  * mRotationAbsolute ;
#line 2581 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
bReferenceMovingInY  = (vReferenceDelta  % en_vGravityDir  != 0.0f);
#line 2582 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
bReferenceRotatingNonY  = ((en_vGravityDir  * mReferenceRotation ) % en_vGravityDir ) > 0.01f;
#line 2583 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
#line 2585 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
FLOAT3D vTranslationAbsolute  = en_vCurrentTranslationAbsolute  * fTickQuantum ;
#line 2588 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
en_ulPhysicsFlags  &= ~ EPF_ORIENTINGTOGRAVITY ;
#line 2590 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
if(en_ulPhysicsFlags  & EPF_ORIENTEDBYGRAVITY ){
#line 2592 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
FLOAT3D vDown ;
#line 2593 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
vDown  (1) = - en_mRotation  (1 , 2);
#line 2594 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
vDown  (2) = - en_mRotation  (2 , 2);
#line 2595 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
vDown  (3) = - en_mRotation  (3 , 2);
#line 2598 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
FLOAT fCos  = vDown  % en_vGravityDir ;
#line 2600 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
if(fCos  < 0.99999f){
#line 2602 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
en_ulPhysicsFlags  |= EPF_ORIENTINGTOGRAVITY ;
#line 2605 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
ANGLE a  = ACos  (fCos );
#line 2606 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
if(Abs  (a ) > 20){
#line 2607 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
a  = 20 * Sgn  (a );
#line 2608 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
#line 2609 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
FLOAT fRad  = RadAngle  (a );
#line 2612 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
FLOAT3D vAxis  = vDown  * en_vGravityDir ;
#line 2613 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
FLOAT fLen  = vAxis  . Length  ();
#line 2614 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
if(fLen  < 0.01f){
#line 2615 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
vAxis  (1) = en_mRotation  (1 , 3);
#line 2616 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
vAxis  (2) = en_mRotation  (2 , 3);
#line 2617 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
vAxis  (3) = en_mRotation  (3 , 3);
#line 2620 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}else if(! bReferenceRotatingNonY ){
#line 2621 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
fRad  /= fLen ;
#line 2622 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
#line 2623 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
vAxis  *= fRad ;
#line 2626 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
FLOATmatrix3D mGRotation ;
#line 2627 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
mGRotation  (1 , 1) = 1;mGRotation  (1 , 2) = - vAxis  (3);mGRotation  (1 , 3) = vAxis  (2);
#line 2628 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
mGRotation  (2 , 1) = vAxis  (3);mGRotation  (2 , 2) = 1;mGRotation  (2 , 3) = - vAxis  (1);
#line 2629 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
mGRotation  (3 , 1) = - vAxis  (2);mGRotation  (3 , 2) = vAxis  (1);mGRotation  (3 , 3) = 1;
#line 2630 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
OrthonormalizeRotationMatrix  (mGRotation );
#line 2633 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
mRotationAbsolute  = mGRotation  * mRotationAbsolute ;
#line 2634 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
#line 2635 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
#line 2638 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
en_ulPhysicsFlags  &= ~ EPF_FLOATING ;
#line 2640 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
FLOAT ACC  = en_fAcceleration  * fTickQuantum  * fTickQuantum ;
#line 2641 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
FLOAT DEC  = en_fDeceleration  * fTickQuantum  * fTickQuantum ;
#line 2643 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
if(! (en_ulPhysicsFlags  & EPF_TRANSLATEDBYGRAVITY )){
#line 2645 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
if(en_ulPhysicsFlags  & EPF_NOACCELERATION ){
#line 2646 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
vTranslationAbsolute  = vDesiredTranslationAbsolute ;
#line 2647 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}else {
#line 2648 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
AddAcceleration  (vTranslationAbsolute  , vDesiredTranslationAbsolute  , 
#line 2649 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
ACC  * fControlMultiplier  , 
#line 2650 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
DEC  * fControlMultiplier );
#line 2651 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
#line 2653 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}else if((fBouyancy  * en_fGravityA  < 0.5f && (ctDn  . ct_ulFlags  & (CTF_SWIMABLE  | CTF_FLYABLE )))){
#line 2655 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
en_ulPhysicsFlags  |= EPF_FLOATING ;
#line 2657 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
if(en_ulPhysicsFlags  & EPF_NOACCELERATION ){
#line 2658 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
vTranslationAbsolute  = vDesiredTranslationAbsolute ;
#line 2659 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}else {
#line 2660 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
AddAcceleration  (vTranslationAbsolute  , vDesiredTranslationAbsolute  , 
#line 2661 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
ACC  * fControlMultiplier  , 
#line 2662 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
DEC  * fControlMultiplier );
#line 2663 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
#line 2666 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
if(fBouyancy  < - 0.1f){
#line 2667 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
FLOAT fGV  = en_fGravityV  * fTickQuantum  * fSpeedModifier ;
#line 2668 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
FLOAT fGA  = (en_fGravityA  * - fBouyancy ) * fTickQuantum  * fTickQuantum ;
#line 2669 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
AddAcceleration  (vTranslationAbsolute  , en_vGravityDir  * - fGV  , fGA  , fGA );
#line 2670 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}else if(fBouyancy  > + 0.1f){
#line 2671 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
FLOAT fGV  = en_fGravityV  * fTickQuantum  * fSpeedModifier ;
#line 2672 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
FLOAT fGA  = (en_fGravityA  * fBouyancy ) * fTickQuantum  * fTickQuantum ;
#line 2673 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
AddAcceleration  (vTranslationAbsolute  , en_vGravityDir  * fGV  , fGA  , fGA );
#line 2674 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
#line 2677 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}else {
#line 2678 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
BOOL bGravityAlongPolygon  = TRUE ;
#line 2680 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
if(en_pbpoStandOn  == NULL  || ! IsStandingOnPolygon  (en_pbpoStandOn ) || bReferenceMovingInY  
#line 2681 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
|| (en_ulPhysicsFlags  & EPF_ORIENTINGTOGRAVITY )){
#line 2683 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
en_pbpoStandOn  = NULL ;
#line 2684 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
if(en_penReference  == NULL  || bReferenceMovingInY ){
#line 2685 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
bGravityAlongPolygon  = FALSE ;
#line 2686 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
#line 2687 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
#line 2690 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
if(! bGravityAlongPolygon ){
#line 2691 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
_pfPhysicsProfile  . IncrementCounter  (CPhysicsProfile  :: PCI_GRAVITY_NONTRIVIAL );
#line 2694 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
FLOAT fGV  = en_fGravityV  * fTickQuantum  * fSpeedModifier ;
#line 2695 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
FLOAT fGA  = (en_fGravityA  * fBouyancy ) * fTickQuantum  * fTickQuantum ;
#line 2696 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
AddGAcceleration  (vTranslationAbsolute  , en_vGravityDir  , fGA  , fGV );
#line 2698 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}else {
#line 2699 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
_pfPhysicsProfile  . IncrementCounter  (CPhysicsProfile  :: PCI_GRAVITY_TRIVIAL );
#line 2702 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
FLOAT3D vPolygonDir  = - en_vReferencePlane ;
#line 2704 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
FLOAT3D vGParallel  , vGNormal ;
#line 2705 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
GetParallelAndNormalComponents  (en_vGravityDir  , vPolygonDir  , vGNormal  , vGParallel );
#line 2707 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
FLOAT fFactor  = vGParallel  . Length  ();
#line 2709 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
if(fFactor  > 0.001f){
#line 2710 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
FLOAT fGV  = en_fGravityV  * fTickQuantum  * fSpeedModifier ;
#line 2711 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
FLOAT fGA  = (en_fGravityA  * fBouyancy ) * fTickQuantum  * fTickQuantum ;
#line 2712 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
AddGAcceleration  (vTranslationAbsolute  , vGParallel  / fFactor  , fGA  * fFactor  , fGV  * fFactor );
#line 2713 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
#line 2716 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
FLOAT fPolyGA  = (vPolygonDir  % en_vGravityDir ) * en_fGravityA ;
#line 2717 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
FLOAT fYSpeed  = vPolygonDir  % vTranslationAbsolute ;
#line 2718 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
if(fYSpeed  > 0 && fYSpeed  < fPolyGA ){
#line 2719 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
vTranslationAbsolute  -= vPolygonDir  * fYSpeed ;
#line 2720 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
#line 2723 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
if((en_ulPhysicsFlags  & EPF_ONBLOCK_MASK ) == EPF_ONBLOCK_BOUNCE ){
#line 2725 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
en_aDesiredRotationRelative  *= en_fJumpControlMultiplier ;
#line 2726 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
if(en_aDesiredRotationRelative  . Length  () < 10){
#line 2727 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
en_aDesiredRotationRelative  = ANGLE3D (0 , 0 , 0);
#line 2728 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
#line 2729 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
#line 2730 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
#line 2732 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
CSurfaceType  & stReference  = en_pwoWorld  -> wo_astSurfaceTypes  [ en_iReferenceSurface  ];
#line 2735 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
if(en_penReference  != NULL ){
#line 2736 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
FLOAT fPlaneY  = (en_vGravityDir  % en_vReferencePlane );
#line 2737 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
FLOAT fPlaneYAbs  = Abs  (fPlaneY );
#line 2738 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
FLOAT fFriction  = stReference  . st_fFriction ;
#line 2740 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
if((fPlaneY  >= - stReference  . st_fClimbSlopeCos  && fPlaneY  < 0) 
#line 2741 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
|| ((stReference  . st_ulFlags  & STF_SLIDEDOWNSLOPE ) && fPlaneY  > - 0.99f)){
#line 2742 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
en_ulPhysicsFlags  |= EPF_ONSTEEPSLOPE ;
#line 2744 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
AddAccelerationOnPlane2  (
#line 2745 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
vTranslationAbsolute  , 
#line 2746 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
vDesiredTranslationAbsolute  , 
#line 2747 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
ACC  * fPlaneYAbs  * fPlaneYAbs  * fFriction  * fControlMultiplier  , 
#line 2748 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
DEC  * fPlaneYAbs  * fPlaneYAbs  * fFriction  * fControlMultiplier  , 
#line 2749 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
en_vReferencePlane  , 
#line 2750 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
en_vGravityDir );
#line 2752 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}else {
#line 2753 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
en_ulPhysicsFlags  &= ~ EPF_ONSTEEPSLOPE ;
#line 2755 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
AddAccelerationOnPlane  (
#line 2756 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
vTranslationAbsolute  , 
#line 2757 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
vDesiredTranslationAbsolute  , 
#line 2758 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
ACC  * fPlaneYAbs  * fPlaneYAbs  * fFriction  * fControlMultiplier  , 
#line 2759 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
DEC  * fPlaneYAbs  * fPlaneYAbs  * fFriction  * fControlMultiplier  , 
#line 2760 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
en_vReferencePlane );
#line 2761 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
#line 2763 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
if(fJump  < - 0.01f && (fPlaneY  < - stReference  . st_fJumpSlopeCos  
#line 2764 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
|| _pTimer  -> CurrentTick  () > en_tmLastSignificantVerticalMovement  + 0.25f)){
#line 2766 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
vTranslationAbsolute  += en_vGravityDir  * fJump ;
#line 2767 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
en_tmJumped  = _pTimer  -> CurrentTick  ();
#line 2768 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
en_pbpoStandOn  = NULL ;
#line 2769 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
#line 2772 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}else {
#line 2774 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
if(_pTimer  -> CurrentTick  () - en_tmJumped  < en_tmMaxJumpControl ){
#line 2776 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
AddAccelerationOnPlane  (
#line 2777 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
vTranslationAbsolute  , 
#line 2778 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
vDesiredTranslationAbsolute  , 
#line 2779 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
ACC  * fControlMultiplier  * en_fJumpControlMultiplier  , 
#line 2780 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
DEC  * fControlMultiplier  * en_fJumpControlMultiplier  , 
#line 2781 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
FLOATplane3D (en_vGravityDir  , 0));
#line 2782 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
#line 2785 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
if(fJump  < - 0.01f && 
#line 2786 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
_pTimer  -> CurrentTick  () > en_tmLastSignificantVerticalMovement  + 0.25f){
#line 2788 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
vTranslationAbsolute  += en_vGravityDir  * fJump ;
#line 2789 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
en_tmJumped  = _pTimer  -> CurrentTick  ();
#line 2790 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
en_pbpoStandOn  = NULL ;
#line 2791 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
#line 2792 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
#line 2793 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
#line 2797 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
CheckAndAddGAcceleration  (this  , vTranslationAbsolute  , fTickQuantum );
#line 2800 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
if(fFluidFriction  > 0.01f){
#line 2802 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
AddAcceleration  (vTranslationAbsolute  , FLOAT3D (0.0f , 0.0f , 0.0f) , 
#line 2803 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
0.0f , DEC  * fFluidFriction );
#line 2804 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
#line 2807 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
if((en_ulPhysicsFlags  & EPF_CANFADESPINNING ) && 
#line 2808 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
((ctDn  . ct_ulFlags  & CTF_FADESPINNING ) || (ctUp  . ct_ulFlags  & CTF_FADESPINNING ))){
#line 2810 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
en_aDesiredRotationRelative  *= (1 - fSpeedModifier  * 0.05f);
#line 2811 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
if(en_aDesiredRotationRelative  . Length  () < 10){
#line 2812 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
en_aDesiredRotationRelative  = ANGLE3D (0 , 0 , 0);
#line 2813 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
#line 2814 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
#line 2817 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
if(en_pbpoStandOn  == NULL ){
#line 2818 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
en_penReference  = NULL ;
#line 2819 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
en_vReferencePlane  = FLOAT3D (0.0f , 0.0f , 0.0f);
#line 2820 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
en_iReferenceSurface  = 0;
#line 2821 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
#line 2823 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
en_vIntendedTranslation  = vTranslationAbsolute ;
#line 2824 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
en_mIntendedRotation  = mRotationAbsolute ;
#line 2829 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
FLOATaabbox3D box ;
#line 2830 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
en_pciCollisionInfo  -> MakeBoxAtPlacement  (FLOAT3D (0 , 0 , 0) , en_mRotation  , box );
#line 2832 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
{CLightSource  * pls  = GetLightSource  ();
#line 2833 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
if(pls  != NULL  && ! (pls  -> ls_ulFlags  & LSF_LENSFLAREONLY )){
#line 2835 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
ASSERT  (! (pls  -> ls_ulFlags  & LSF_DIRECTIONAL ));
#line 2836 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
box  |= FLOATaabbox3D (FLOAT3D (0 , 0 , 0) , pls  -> ls_rFallOff );
#line 2837 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}}
#line 2839 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
box  . ExpandByFactor  (phy_fCollisionCacheAround  - 1.0f);
#line 2841 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
box  += en_plPlacement  . pl_PositionVector ;
#line 2842 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
en_boxMovingEstimate  = box ;
#line 2843 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
box  += en_vIntendedTranslation  * phy_fCollisionCacheAhead ;
#line 2844 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
en_boxMovingEstimate  |= box ;
#line 2847 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
en_vAppliedTranslation  = FLOAT3D (0.0f , 0.0f , 0.0f);
#line 2848 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
en_mAppliedRotation  . Diagonal  (1.0f);
#line 2849 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
_pfPhysicsProfile  . StopTimer  (CPhysicsProfile  :: PTI_PREMOVING );
#line 2851 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
  void CMovableEntity::DoMoving(void) 
#line 2855 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
{
#line 2856 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
if(en_pciCollisionInfo  == NULL  || (en_ulPhysicsFlags  & EPF_FORCEADDED )){
#line 2857 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
return ;
#line 2858 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
#line 2861 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
_pfPhysicsProfile  . StartTimer  ((INDEX) CPhysicsProfile  :: PTI_DOMOVING );
#line 2862 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
_pfPhysicsProfile  . IncrementTimerAveragingCounter  ((INDEX) CPhysicsProfile  :: PTI_DOMOVING );
#line 2864 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
_pfPhysicsProfile  . IncrementCounter  ((INDEX) CPhysicsProfile  :: PCI_DOMOVING );
#line 2869 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
if(en_ulPhysicsFlags  & EPF_RT_SYNCHRONIZED ){
#line 2870 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
_pfPhysicsProfile  . IncrementCounter  ((INDEX) CPhysicsProfile  :: PCI_DOMOVING_SYNC );
#line 2873 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
en_vMoveTranslation  = en_vIntendedTranslation  - en_vAppliedTranslation ;
#line 2874 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
en_mMoveRotation  = en_mIntendedRotation  * ! en_mAppliedRotation ;
#line 2876 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
InitTryToMove  ();
#line 2877 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
CMovableEntity  * penPusher  = NULL ;
#line 2878 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
if((en_ulPhysicsFlags  & EPF_ONBLOCK_MASK ) == EPF_ONBLOCK_PUSH ){
#line 2879 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
penPusher  = this ;
#line 2880 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
#line 2881 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
TryToMove  (penPusher  , TRUE  , TRUE );
#line 2884 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}else {
#line 2885 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
ASSERT  ((en_ulPhysicsFlags  & EPF_ONBLOCK_MASK ) != EPF_ONBLOCK_PUSH );
#line 2886 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
_pfPhysicsProfile  . IncrementCounter  ((INDEX) CPhysicsProfile  :: PCI_DOMOVING_ASYNC );
#line 2889 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
if(en_penReference  == NULL ){
#line 2890 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
_pfPhysicsProfile  . IncrementCounter  ((INDEX) CPhysicsProfile  :: PCI_DOMOVING_ASYNC_SYNCTRY );
#line 2893 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
en_vMoveTranslation  = en_vIntendedTranslation  - en_vAppliedTranslation ;
#line 2894 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
en_mMoveRotation  = en_mIntendedRotation  * ! en_mAppliedRotation ;
#line 2895 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
InitTryToMove  ();
#line 2896 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
_ctTryToMoveCheckCounter  = 4;
#line 2897 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
BOOL bMoveSuccessfull  = TryToMove  (NULL  , TRUE  , TRUE );
#line 2899 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
if(bMoveSuccessfull ){
#line 2901 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
_pfPhysicsProfile  . IncrementCounter  ((INDEX) CPhysicsProfile  :: PCI_DOMOVING_ASYNC_SYNCPASS );
#line 2902 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
_pfPhysicsProfile  . StopTimer  ((INDEX) CPhysicsProfile  :: PTI_DOMOVING );
#line 2904 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
return ;
#line 2905 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
#line 2906 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
#line 2908 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
_pfPhysicsProfile  . IncrementCounter  ((INDEX) CPhysicsProfile  :: PCI_DOMOVING_ASYNC_TRANSLATE );
#line 2910 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
en_vMoveTranslation  = en_vIntendedTranslation  - en_vAppliedTranslation ;
#line 2911 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
InitTryToMove  ();
#line 2912 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
TryToMove  (NULL  , TRUE  , FALSE );
#line 2915 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
en_mMoveRotation  = en_mIntendedRotation  * ! en_mAppliedRotation ;
#line 2916 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
if(
#line 2917 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
en_mMoveRotation  (1 , 1) != 1 || en_mMoveRotation  (1 , 2) != 0 || en_mMoveRotation  (1 , 3) != 0 || 
#line 2918 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
en_mMoveRotation  (2 , 1) != 0 || en_mMoveRotation  (2 , 2) != 1 || en_mMoveRotation  (2 , 3) != 0 || 
#line 2919 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
en_mMoveRotation  (3 , 1) != 0 || en_mMoveRotation  (3 , 2) != 0 || en_mMoveRotation  (3 , 3) != 1){
#line 2920 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
_pfPhysicsProfile  . IncrementCounter  ((INDEX) CPhysicsProfile  :: PCI_DOMOVING_ASYNC_ROTATE );
#line 2921 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
InitTryToMove  ();
#line 2922 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
TryToMove  (NULL  , FALSE  , TRUE );
#line 2923 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
#line 2924 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
#line 2926 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
_pfPhysicsProfile  . StopTimer  ((INDEX) CPhysicsProfile  :: PTI_DOMOVING );
#line 2928 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
  void CMovableEntity::PostMoving(void) 
#line 2932 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
{
#line 2933 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
if(en_pciCollisionInfo  == NULL ){
#line 2935 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
en_ulFlags  |= ENF_INRENDERING ;
#line 2936 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
return ;
#line 2937 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
#line 2939 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
if(en_ulPhysicsFlags  & EPF_FORCEADDED ){
#line 2940 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
en_ulPhysicsFlags  &= ~ EPF_FORCEADDED ;
#line 2941 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
return ;
#line 2942 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
#line 2946 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
_pfPhysicsProfile  . StartTimer  ((INDEX) CPhysicsProfile  :: PTI_POSTMOVING );
#line 2947 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
_pfPhysicsProfile  . IncrementTimerAveragingCounter  ((INDEX) CPhysicsProfile  :: PTI_POSTMOVING );
#line 2950 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
if(en_penReference  != NULL ){
#line 2951 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
en_penLastValidReference  = en_penReference ;
#line 2952 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
#line 2955 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
FLOAT3D vOldTranslation  = en_vCurrentTranslationAbsolute ;
#line 2956 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
FLOAT fTickQuantum  = _pTimer  -> TickQuantum ;
#line 2958 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
en_vCurrentTranslationAbsolute  = en_vAppliedTranslation  / fTickQuantum ;
#line 2961 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
if(Abs  (en_vCurrentTranslationAbsolute  % en_vGravityDir ) > 0.1f){
#line 2962 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
en_tmLastSignificantVerticalMovement  = _pTimer  -> CurrentTick  ();
#line 2963 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
#line 2965 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
ClearNextPosition  ();
#line 2968 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
FLOAT3D vSpeedDelta  = en_vIntendedTranslation  - en_vAppliedTranslation ;
#line 2969 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
FLOAT fSpeedDelta  = vSpeedDelta  . Length  () / fTickQuantum ;
#line 2972 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
if(fSpeedDelta  > en_fCollisionSpeedLimit  && 
#line 2973 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
! (en_ulPhysicsFlags  & EPF_NOIMPACTTHISTICK )){
#line 2975 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
FLOAT fDamage  = ((fSpeedDelta  - en_fCollisionSpeedLimit ) / en_fCollisionSpeedLimit ) * en_fCollisionDamageFactor ;
#line 2976 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
InflictDirectDamage  (this  , MiscDamageInflictor  () , DMT_IMPACT  , fDamage  , 
#line 2977 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
en_plPlacement  . pl_PositionVector  , - vSpeedDelta  . Normalize  ());
#line 2978 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
#line 2979 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
en_ulPhysicsFlags  &= ~ EPF_NOIMPACTTHISTICK ;
#line 2982 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
en_vIntendedTranslation  = vOldTranslation ;
#line 2985 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
if(en_vCurrentTranslationAbsolute  . ManhattanNorm  () < 0.001f 
#line 2986 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
&& (en_vDesiredTranslationRelative  . ManhattanNorm  () == 0 || en_fAcceleration  == 0) 
#line 2987 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
&& en_aDesiredRotationRelative  . ManhattanNorm  () == 0){
#line 2990 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
if(en_penReference  != NULL ){
#line 2992 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
if(en_penReference  -> en_ulPhysicsFlags  & EPF_MOVABLE ){
#line 2993 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
CMovableEntity  * penReference  = (CMovableEntity  *) (CEntity  *) en_penReference ;
#line 2995 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
if(! penReference  -> en_lnInMovers  . IsLinked  ()){
#line 2997 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
en_ulFlags  |= ENF_INRENDERING ;
#line 2998 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
#line 3000 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}else {
#line 3002 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
en_ulFlags  |= ENF_INRENDERING ;
#line 3003 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
#line 3006 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}else {
#line 3008 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
if(
#line 3009 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
(! (en_ulPhysicsFlags  & (EPF_TRANSLATEDBYGRAVITY  | EPF_ORIENTEDBYGRAVITY )) 
#line 3010 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
|| en_fGravityA  == 0.0f)){
#line 3012 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
en_ulFlags  |= ENF_INRENDERING ;
#line 3013 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
#line 3014 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
#line 3017 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
if(en_ulFlags  & ENF_INRENDERING ){
#line 3019 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
en_plLastPlacement  = en_plPlacement ;
#line 3020 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
#line 3021 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
#line 3024 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
if(en_plpLastPositions  != NULL ){
#line 3025 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
en_plpLastPositions  -> AddPosition  (en_vNextPosition );
#line 3026 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
#line 3030 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
extern  BOOL _bPredictionActive ;
#line 3031 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
if(_bPredictionActive  && (IsPredictable  () || IsPredictor  ())){
#line 3032 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
CMovableEntity  * penTail  = (CMovableEntity  *) GetPredictedSafe  (this );
#line 3033 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
TIME  tmNow  = _pTimer  -> CurrentTick  ();
#line 3035 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
if(penTail  -> en_tmLastPredictionHead  < - 1){
#line 3036 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
penTail  -> en_vLastHead  = en_plPlacement  . pl_PositionVector ;
#line 3037 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
penTail  -> en_vPredError  = FLOAT3D (0 , 0 , 0);
#line 3038 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
penTail  -> en_vPredErrorLast  = FLOAT3D (0 , 0 , 0);
#line 3039 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
#line 3042 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
if(IsPredictor  ()){
#line 3044 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
if(penTail  -> en_tmLastPredictionHead  == tmNow  || penTail  -> en_tmLastPredictionHead  < 0){
#line 3046 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
penTail  -> en_vPredErrorLast  = penTail  -> en_vPredError ;
#line 3047 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
penTail  -> en_vPredError  += 
#line 3048 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
en_plPlacement  . pl_PositionVector  - penTail  -> en_vLastHead ;
#line 3050 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
penTail  -> en_vLastHead  = en_plPlacement  . pl_PositionVector ;
#line 3052 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
if(IsPredictionHead  ()){
#line 3054 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
penTail  -> en_tmLastPredictionHead  = tmNow ;
#line 3055 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
#line 3058 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}else if(tmNow  > penTail  -> en_tmLastPredictionHead ){
#line 3060 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
penTail  -> en_vLastHead  = en_plPlacement  . pl_PositionVector ;
#line 3061 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
penTail  -> en_tmLastPredictionHead  = tmNow ;
#line 3062 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
#line 3065 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}else if(! (en_ulFlags  & ENF_WILLBEPREDICTED )){
#line 3067 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
if(penTail  -> en_tmLastPredictionHead  > 0){
#line 3069 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
penTail  -> en_vPredErrorLast  = penTail  -> en_vPredError ;
#line 3070 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
penTail  -> en_vPredError  += 
#line 3071 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
en_plPlacement  . pl_PositionVector  - penTail  -> en_vLastHead ;
#line 3072 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
#line 3074 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
penTail  -> en_vLastHead  = en_plPlacement  . pl_PositionVector ;
#line 3075 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
penTail  -> en_tmLastPredictionHead  = - 1;
#line 3076 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
#line 3078 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
if(IsPredictionHead  ()){
#line 3080 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
penTail  -> en_vPredErrorLast  = penTail  -> en_vPredError ;
#line 3081 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
penTail  -> en_vPredError  *= cli_fPredictionFilter ;
#line 3086 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
#line 3087 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
#line 3090 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
_pfPhysicsProfile  . StopTimer  ((INDEX) CPhysicsProfile  :: PTI_POSTMOVING );
#line 3093 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
  void CMovableEntity::CacheNearPolygons(void) 
#line 3097 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
{
#line 3098 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
CClipMove  cm  (this );
#line 3099 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
cm  . CacheNearPolygons  ();
#line 3100 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
  
#line 3104 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
SLONG CMovableEntity::GetUsedMemory(void) 
#line 3105 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
{
#line 3107 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
SLONG  slUsedMemory  = sizeof  (CMovableEntity ) - sizeof  (CRationalEntity ) + CRationalEntity  :: GetUsedMemory  ();
#line 3109 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
slUsedMemory  += en_apbpoNearPolygons  . sa_Count  * sizeof  (CBrushPolygon  *);
#line 3110 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
return slUsedMemory ;
#line 3111 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
}
BOOL CMovableEntity::
#line 3118 "/builddir/build/BUILD/serioussam-1.10.6d+dfsg/SamTFE/Sources/Engine/Classes/MovableEntity.es"
Dummy(const CEntityEvent &__eeInput) {
#undef STATE_CURRENT
#define STATE_CURRENT STATE_CMovableEntity_Dummy
  ASSERTMSG(__eeInput.ee_slEvent==EVENTCODE_EVoid, "CMovableEntity::Dummy expects 'EVoid' as input!");  const EVoid &e = (const EVoid &)__eeInput; ASSERT(FALSE); return TRUE;};